using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Globalization;
using System.Windows.Forms;

using TestProject.Properties;

namespace TestProject
{
    /// <summary>
    /// ̽ 
    /// </summary>
    [DesignTimeVisibleAttribute(false)]
    public class BasePanel : ScrollableControl, IPanel
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Event
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region г Ÿ  ̺Ʈ - PanelStyleChanged

        /// <summary>
        /// г Ÿ  ̺Ʈ
        /// </summary>
        public event EventHandler<PanelStyleChangedEventArgs> PanelStyleChanged;

        #endregion
        #region  Ŵ  ̺Ʈ - ColorSchemeChanged

        /// <summary>
        ///  Ŵ  ̺Ʈ
        /// </summary>
        public event EventHandler<ColorSchemeChangedEventArgs> ColorSchemeChanged;

        #endregion
        #region Ŀ   ̺Ʈ - CustomColorsChanged

        /// <summary>
        /// Ŀ   ̺Ʈ
        /// </summary>
        public event EventHandler<EventArgs> CustomColorsChanged;

        #endregion
        #region    ̺Ʈ - CaptionHeightChanged

        /// <summary>
        ///    ̺Ʈ
        /// </summary>
        public event EventHandler<EventArgs> CaptionHeightChanged;

        #endregion
        #region   ȣ   ̺Ʈ - CaptionBarHoverStateChanged

        /// <summary>
        ///   ȣ   ̺Ʈ
        /// </summary>
        public event EventHandler<HoverStateChangedEventArgs> CaptionBarHoverStateChanged;

        #endregion
        #region ݱ ư ȣ   ̺Ʈ - CloseButtonHoverStateChanged

        /// <summary>
        /// ݱ ư ȣ   ̺Ʈ
        /// </summary>
        protected event EventHandler<HoverStateChangedEventArgs> CloseButtonHoverStateChanged;

        #endregion
        #region ݱ ư Ŭ ̺Ʈ - CloseButtonClick

        /// <summary>
        /// ݱ ư Ŭ ̺Ʈ
        /// </summary>
        public event EventHandler<EventArgs> CloseButtonClick;

        #endregion
        #region Ȯ ư ȣ   óϱ - ExpandButtonHoverStateChanged

        /// <summary>
        /// Ȯ  ȣ   óϱ
        /// </summary>
        protected event EventHandler<HoverStateChangedEventArgs> ExpandButtonHoverStateChanged;

        #endregion
        #region Ȯ ư Ŭ ̺Ʈ - ExpandButtonClick

        /// <summary>
        /// Ȯ ư Ŭ ̺Ʈ
        /// </summary>
        public event EventHandler<EventArgs> ExpandButtonClick;

        #endregion
        #region г ҽ ̺Ʈ - PanelCollapsed

        /// <summary>
        /// г ҽ ̺Ʈ
        /// </summary>
        public event EventHandler<PanelStateChangedEventArgs> PanelCollapsed;

        #endregion
        #region г Ȯ ̺Ʈ - PanelExpanded

        /// <summary>
        /// г Ȯ ̺Ʈ
        /// </summary>
        public event EventHandler<PanelStateChangedEventArgs> PanelExpanded;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        ///  
        /// </summary>
        public const int CAPTION_SPACING = 6;

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region Field

        /// <summary>
        /// Ȯ ư 簢
        /// </summary>
        protected Rectangle ExpandButtonRectangle = Rectangle.Empty;

        /// <summary>
        /// ݱ ư 簢
        /// </summary>
        protected Rectangle CloseButtonRectangle = Rectangle.Empty;

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// г Ÿ
        /// </summary>
        private PanelStyle panelStyle;

        /// <summary>
        ///  Ŵ
        /// </summary>
        private ColorScheme colorScheme;

        /// <summary>
        /// г 
        /// </summary>
        private PanelColor panelColor;

        /// <summary>
        /// ׵θ ǥ 
        /// </summary>
        private bool showBorder;

        /// <summary>
        /// ̹ ũ
        /// </summary>
        private Size imageSize;

        /// <summary>
        /// ̹ 簢
        /// </summary>
        private Rectangle imageRectangle;

        /// <summary>
        /// ̹
        /// </summary>
        private Image image;

        /// <summary>
        ///  
        /// </summary>
        private int captionHeight;

        /// <summary>
        ///  Ʈ
        /// </summary>
        private Font captionFont;

        /// <summary>
        ///   ȣ 
        /// </summary>
        private HoverState captionBarHoverState;

        /// <summary>
        /// Ȯ ư ǥ 
        /// </summary>
        private bool showExpandButton;

        /// <summary>
        /// Ȯ ư ȣ 
        /// </summary>
        private HoverState expandButtonHoverState;

        /// <summary>
        /// Ȯ ư  ؽƮ 1 (ҽ)
        /// </summary>
        private string expandButtonToolTipText1;

        /// <summary>
        /// Ȯ ư  ؽƮ 2 (Ȯ)
        /// </summary>
        private string expandButtonToolTipText2;

        /// <summary>
        /// ݱ ư ǥ 
        /// </summary>
        private bool showCloseButton;

        /// <summary>
        /// ݱ ư ȣ 
        /// </summary>
        private HoverState closeButtonHoverState;

        /// <summary>
        /// ݱ ư  ؽƮ
        /// </summary>
        private string closeButtonToolTipText;

        /// <summary>
        /// 
        /// </summary>
        private ToolTip toolTip;

        /// <summary>
        /// Ȯ 
        /// </summary>
        private bool expanded;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region ̹ ũ - ImageSize

        /// <summary>
        /// ̹ ũ
        /// </summary>
        internal Size ImageSize
        {
            get
            {
                return this.imageSize;
            }
            set
            {
                this.imageSize = value;
            }
        }

        #endregion
        #region ̹ 簢 - ImageRectangle

        /// <summary>
        /// ̹ 簢
        /// </summary>
        internal Rectangle ImageRectangle
        {
            get
            {
                if(this.imageRectangle == Rectangle.Empty)
                {
                    this.imageRectangle = new Rectangle
                    (
                        CAPTION_SPACING,
                        CaptionHeight,
                        this.imageSize.Width,
                        this.imageSize.Height
                    );
                }

                return this.imageRectangle;
            }
        }

        #endregion
        #region   ȣ  - CaptionBarHoverState

        /// <summary>
        ///   ȣ 
        /// </summary>
        internal HoverState CaptionBarHoverState
        {
            get
            {
                return this.captionBarHoverState;
            }
            set
            {
                this.captionBarHoverState = value;
            }
        }

        #endregion
        #region  簢 - CaptionRectangle

        /// <summary>
        ///  簢
        /// </summary>
        internal Rectangle CaptionRectangle
        {
            get
            {
                return new Rectangle
                (
                    0,
                    0,
                    ClientRectangle.Width,
                    CaptionHeight
                );
            }
        }

        #endregion
        #region Ȯ ư ȣ  - ExpandButtonHoverState 

        /// <summary>
        /// Ȯ ư ȣ 
        /// </summary>
        internal HoverState ExpandButtonHoverState
        {
            get
            {
                return this.expandButtonHoverState;
            }
            set
            {
                this.expandButtonHoverState = value;
            }
        }

        #endregion
        #region ݱ ư ȣ  - CloseButtonHoverState

        /// <summary>
        /// ݱ ư ȣ 
        /// </summary>
        internal HoverState CloseButtonHoverState
        {
            get
            {
                return this.closeButtonHoverState;
            }
            set
            {
                this.closeButtonHoverState = value;
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region г Ÿ - PanelStyle

        /// <summary>
        /// г Ÿ
        /// </summary>
        [Category(nameof(BasePanel))]
        [DefaultValue(0)]
        public virtual PanelStyle PanelStyle
        {
            get
            {
                return this.panelStyle;
            }
            set
            {
                if(value.Equals(this.panelStyle) == false)
                {
                    this.panelStyle = value;

                    OnPanelStyleChanged(this, new PanelStyleChangedEventArgs(this.panelStyle));
                }
            }
        }

        #endregion
        #region  Ŵ - ColorScheme

        /// <summary>
        ///  Ŵ
        /// </summary>
        [Category(nameof(BasePanel))]
        [Browsable(true)]
        [DefaultValue(ColorScheme.Professional)]
        public virtual ColorScheme ColorScheme
        {
            get
            {
                return this.colorScheme;
            }
            set
            {
                if(value.Equals(this.colorScheme) == false)
                {
                    this.colorScheme = value;

                    OnColorSchemeChanged(this, new ColorSchemeChangedEventArgs(this.colorScheme));
                }
            }
        }

        #endregion
        #region ׵θ ǥ  - ShowBorder

        /// <summary>
        /// ׵θ ǥ 
        /// </summary>
        [Category("Appearance")]
        [Browsable(false)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        [DefaultValue(true)]
        public virtual bool ShowBorder
        {
            get
            {
                return this.showBorder;
            }
            set
            {
                if(value.Equals(this.showBorder) == false)
                {
                    this.showBorder = value;

                    Invalidate(false);
                }
            }
        }

        #endregion
        #region ̹ - Image

        /// <summary>
        /// ̹
        /// </summary>
        [Category(nameof(BasePanel))]
        public Image Image
        {
            get
            {
                return this.image;
            }
            set
            {
                if(value != this.image)
                {
                    this.image = value;

                    Invalidate(CaptionRectangle);
                }
            }
        }

        #endregion
        #region   - CaptionHeight

        /// <summary>
        ///    
        /// </summary>
        [Category(nameof(BasePanel))]
        [DefaultValue(25)]
        public int CaptionHeight
        {
            get
            {
                return this.captionHeight;
            }
            set
            {
                if(value < ConstantHelper.CAPTION_MINIMUM_HEIGHT)
                {
                    throw new InvalidOperationException
                    (
                        string.Format
                        (
                            CultureInfo.CurrentUICulture,
                            ConstantHelper.INVALID_OPERATION_EXCEPTION,
                            value,
                            "CaptionHeight",
                            ConstantHelper.CAPTION_MINIMUM_HEIGHT
                        )
                    );
                }

                this.captionHeight = value;

                OnCaptionHeightChanged(this, EventArgs.Empty);
            }
        }

        #endregion
        #region  Ʈ - CaptionFont

        /// <summary>
        ///  Ʈ
        /// </summary>
        [Category(nameof(BasePanel))]
        [DefaultValue(typeof(Font),"Microsoft Sans Serif; 8,25pt; style=Bold")]
        public Font CaptionFont
        {
            get
            {
                return this.captionFont;
            }
            set
            {
                if(value != null)
                {
                    if(value.Equals(this.captionFont) == false)
                    {
                        this.captionFont = value;

                        Invalidate(CaptionRectangle);
                    }
                }
            }
        }

        #endregion
        #region Ȯ ư ǥ  - ShowExpandButton

        /// <summary>
        /// Ȯ ư ǥ 
        /// </summary>
        [Category(nameof(BasePanel))]
        [DefaultValue(false)]
        public virtual bool ShowExpandButton
        {
            get
            {
                return this.showExpandButton;
            }
            set
            {
                if(value.Equals(this.showExpandButton) == false)
                {
                    this.showExpandButton = value;

                    Invalidate(false);
                }
            }
        }

        #endregion
        #region Ȯ ư  ؽƮ 1 (ҽ) - ExpandButtonToolTipText1

        /// <summary>
        /// Ȯ ư  ؽƮ 1 (ҽ)
        /// </summary>
        [Category(nameof(BasePanel))]
        public virtual string ExpandButtonToolTipText1
        {
            get
            {
                return this.expandButtonToolTipText1;
            }
            set
            {
                this.expandButtonToolTipText1 = value;
            }
        }

        #endregion
        #region Ȯ ư  ؽƮ 2 (Ȯ) - ExpandButtonToolTipText2

        /// <summary>
        /// Ȯ ư  ؽƮ 2 (Ȯ)
        /// </summary>
        [Category(nameof(BasePanel))]
        public virtual string ExpandButtonToolTipText2
        {
            get
            {
                return this.expandButtonToolTipText2;
            }
            set
            {
                this.expandButtonToolTipText2 = value;
            }
        }

        #endregion
        #region ݱ ư ǥ  - ShowCloseButton

        /// <summary>
        /// ݱ ư ǥ 
        /// </summary>
        [Category(nameof(BasePanel))]
        [DefaultValue(false)]
        public virtual bool ShowCloseButton
        {
            get
            {
                return this.showCloseButton;
            }
            set
            {
                if(value.Equals(this.showCloseButton) == false)
                {
                    this.showCloseButton = value;

                    Invalidate(false);
                }
            }
        }

        #endregion
        #region ݱ ư  ؽƮ - CloseButtonToolTipText

        /// <summary>
        /// ݱ ư  ؽƮ
        /// </summary>
        [Category(nameof(BasePanel))]
        public virtual string CloseButtonToolTipText
        {
            get
            {
                return this.closeButtonToolTipText;
            }
            set
            {
                this.closeButtonToolTipText = value;
            }
        }

        #endregion
        #region Ȯ  - Expanded

        /// <summary>
        /// Ȯ 
        /// </summary>
        [Category(nameof(BasePanel))]
        [DefaultValue(false)]
        [RefreshProperties(RefreshProperties.Repaint)]
        public virtual bool Expanded
        {
            get
            {
                return this.expanded;
            }
            set
            {
                if(value.Equals(this.expanded) == false)
                {
                    this.expanded = value;

                    if(this.expanded == true)
                    {
                        OnPanelExpanded(this, new PanelStateChangedEventArgs(this.expanded));
                    }
                    else
                    {
                        OnPanelCollapsed(this, new PanelStateChangedEventArgs(this.expanded));
                    }
                }
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region г  - PanelColor

        /// <summary>
        /// г 
        /// </summary>
        protected PanelColor PanelColor
        {
            get
            {
                return this.panelColor;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region  - BasePanel()

        /// <summary>
        /// 
        /// </summary>
        protected BasePanel()
        {
            SetStyle(ControlStyles.ResizeRedraw                , true);
            SetStyle(ControlStyles.AllPaintingInWmPaint        , true);
            SetStyle(ControlStyles.UserPaint                   , true);
            SetStyle(ControlStyles.DoubleBuffer                , true);
            SetStyle(ControlStyles.SupportsTransparentBackColor, true);
            SetStyle(ControlStyles.ContainerControl            , true);

            CaptionFont = new Font
            (
                SystemFonts.CaptionFont.FontFamily,
                SystemFonts.CaptionFont.SizeInPoints - 1.0f,
                FontStyle.Bold
            );

            CaptionHeight = 25;

            PanelStyle = PanelStyle.Default;

            this.panelColor = new PanelColor(this);

            this.imageSize = new Size(16, 16);

            this.imageRectangle = Rectangle.Empty;

            this.toolTip = new ToolTip();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Protected

        #region  ϱ - GetPath(boundRectangle, radius)

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <param name="boundRectangle"> 簢</param>
        /// <param name="radius"></param>
        /// <returns></returns>
        protected static GraphicsPath GetPath(Rectangle boundRectangle, int radius)
        {
            int x      = boundRectangle.X;
            int y      = boundRectangle.Y;
            int width  = boundRectangle.Width;
            int height = boundRectangle.Height;

            GraphicsPath graphicsPath = new GraphicsPath();

            graphicsPath.AddArc(x, y, radius, radius, 180, 90);                                  // » ڳ
            graphicsPath.AddArc(x + width - radius, y, radius, radius, 270, 90);                 //  ڳ
            graphicsPath.AddArc(x + width - radius, y + height - radius, radius, radius, 0, 90); // ϴ ڴ
            graphicsPath.AddArc(x, y + height - radius, radius, radius, 90, 90);                 // ϴ ڳ

            graphicsPath.CloseFigure();

            return graphicsPath;
        }

        #endregion
        #region    ϱ - GetUpperBackgroundPath(boundRectangle, radius)

        /// <summary>
        ///    ϱ
        /// </summary>
        /// <param name="boundRectangle"> 簢</param>
        /// <param name="radius"></param>
        /// <returns>  </returns>
        protected static GraphicsPath GetUpperBackgroundPath(Rectangle boundRectangle, int radius)
        {
            int x      = boundRectangle.X;
            int y      = boundRectangle.Y;
            int width  = boundRectangle.Width;
            int height = boundRectangle.Height;

            GraphicsPath graphicsPath = new GraphicsPath();

            graphicsPath.AddLine(x, y + height, x, y - radius);                  //  
            graphicsPath.AddArc(x, y, radius, radius, 180, 90);                  // » ڳ
            graphicsPath.AddArc(x + width - radius, y, radius, radius, 270, 90); //  ڳ
            graphicsPath.AddLine(x + width, y + radius, x + width, y + height);  //  

            graphicsPath.CloseFigure();

            return graphicsPath;
        }

        #endregion
        #region   ϱ - GetBackgroundPath(boundRectangle, radius)

        /// <summary>
        ///   ϱ
        /// </summary>
        /// <param name="boundRectangle"> 簢</param>
        /// <param name="radius"></param>
        /// <returns> </returns>
        protected static GraphicsPath GetBackgroundPath(Rectangle boundRectangle, int radius)
        {
            int x      = boundRectangle.X;
            int y      = boundRectangle.Y;
            int width  = boundRectangle.Width;
            int height = boundRectangle.Height;

            GraphicsPath graphicsPath = new GraphicsPath();

            graphicsPath.AddArc(x, y, radius, radius, 180, 90);                                  // » ڳ
            graphicsPath.AddArc(x + width - radius, y, radius, radius, 270, 90);                 //  ڳ
            graphicsPath.AddArc(x + width - radius, y + height - radius, radius, radius, 0, 90); // ϴ ڳ
            graphicsPath.AddArc(x, y + height - radius, radius, radius, 90, 90);                 // ϴ ڳ

            graphicsPath.CloseFigure();

            return graphicsPath;
        }

        #endregion

        #region ÷ ͽҴ г  귯 ϱ - GetFlatExpanderPanelCaptionBrush(boundRectangle, beginColor, endColor, isHover)

        /// <summary>
        /// ÷ ͽҴ г  귯 ϱ
        /// </summary>
        /// <param name="boundRectangle"> 簢</param>
        /// <param name="beginColor"> </param>
        /// <param name="endColor"> </param>
        /// <param name="isHover">ȣ </param>
        /// <returns>÷ ͽҴ г  귯</returns>
        protected static LinearGradientBrush GetFlatExpanderPanelCaptionBrush(Rectangle boundRectangle, Color beginColor, Color endColor, bool isHover)
        {
            LinearGradientBrush linearGradientBrush = null;

            Blend blend = new Blend();

            blend.Positions = new float[] { 0.0f, 0.2f, 0.3f, 0.4f, 0.5f, 0.6f, 0.7f, 0.8f, 1.0f };

            if(isHover == false)
            {
                blend.Factors = new float[] { 0.0f, 0.0f, 0.2f, 0.4f, 0.6f, 0.4f, 0.2f, 0.0f, 0.0f };
            }
            else
            {
                blend.Factors = new float[] { 0.4f, 0.5f, 0.6f, 0.8f, 1.0f, 0.8f, 0.6f, 0.5f, 0.4f };
            }

            linearGradientBrush = new LinearGradientBrush(boundRectangle, beginColor, endColor, LinearGradientMode.Horizontal);

            if(linearGradientBrush != null)
            {
                linearGradientBrush.Blend = blend;
            }

            return linearGradientBrush;
        }

        #endregion

        #region ʺ Ǵ  0  ϱ - IsZeroWidthOrHeight(rectangle)

        /// <summary>
        /// ʺ Ǵ  0  ϱ
        /// </summary>
        /// <param name="rectangle">簢</param>
        /// <returns>ʺ Ǵ  0 </returns>
        protected static bool IsZeroWidthOrHeight(Rectangle rectangle)
        {
            if(rectangle.Width != 0)
            {
                return (rectangle.Height == 0);
            }

            return true;
        }

        #endregion

        #region ڿ ׸ - DrawString(graphics, layoutRectangle, font, fontColor, text, rightToLeft, stringAlignment)

        /// <summary>
        /// ڿ ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="layoutRectangle">̾ƿ 簢</param>
        /// <param name="font">Ʈ</param>
        /// <param name="fontColor">Ʈ </param>
        /// <param name="text">ؽƮ</param>
        /// <param name="rightToLeft">ʡ  </param>
        /// <param name="stringAlignment">ڿ </param>
        protected static void DrawString(Graphics graphics, RectangleF layoutRectangle, Font font, Color fontColor, string text, RightToLeft rightToLeft, StringAlignment stringAlignment)
        {
            if(graphics == null)
            {
                throw new ArgumentException
                (
                    string.Format
                    (
                        CultureInfo.CurrentUICulture,
                        ConstantHelper.ARGUMENT_EXCAPTION_MESSAGE,
                        typeof(Graphics).Name
                    )
                );
            }

            using(SolidBrush solidBrush = new SolidBrush(fontColor))
            {
                using(StringFormat stringFormat = new StringFormat())
                {
                    stringFormat.FormatFlags = StringFormatFlags.NoWrap;

                    if(rightToLeft == RightToLeft.Yes)
                    {
                        stringFormat.FormatFlags |= StringFormatFlags.DirectionRightToLeft;
                    }

                    stringFormat.Trimming      = StringTrimming.EllipsisCharacter;
                    stringFormat.LineAlignment = StringAlignment.Center;
                    stringFormat.Alignment     = stringAlignment;

                    graphics.DrawString(text, font, solidBrush, layoutRectangle, stringFormat);
                }
            }
        }

        #endregion

        #region ̹ ׸ - DrawImage(graphics, image, imageRectangle)

        /// <summary>
        /// ̹ ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="image">̹</param>
        /// <param name="imageRectangle">̹ 簢</param>
        protected static void DrawImage(Graphics graphics, Image image, Rectangle imageRectangle)
        {
            if(graphics == null)
            {
                throw new ArgumentNullException
                (
                    string.Format
                    (
                        CultureInfo.CurrentUICulture,
                        ConstantHelper.ARGUMENT_EXCAPTION_MESSAGE,
                        typeof(Graphics).Name
                    )
                );
            }

            if(image != null)
            {
                graphics.DrawImage(image, imageRectangle);
            }
        }

        #endregion
        #region ̹ ׸ - DrawImage(graphics, image, imageRectangle, color, y)

        /// <summary>
        /// ̹ ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="image">̹</param>
        /// <param name="imageRectangle">̹ 簢</param>
        /// <param name="color"></param>
        /// <param name="y">Y ǥ</param>
        protected static void DrawImage(Graphics graphics, Image image, Rectangle imageRectangle, Color color, int y)
        {
            if(graphics == null)
            {
                throw new ArgumentException
                (
                    string.Format
                    (
                        CultureInfo.CurrentUICulture,
                        ConstantHelper.ARGUMENT_EXCAPTION_MESSAGE,
                        typeof(Graphics).Name
                    )
                );
            }

            if(image == null)
            {
                throw new ArgumentException
                (
                    string.Format
                    (
                        CultureInfo.CurrentUICulture,
                        ConstantHelper.ARGUMENT_EXCAPTION_MESSAGE,
                        typeof(Image).Name
                    )
                );
            }

            int imageX      = imageRectangle.Left;
            int imageWidth  = image.Width;
            int imageHeight = image.Height;

            Rectangle targetRectangle = new Rectangle
            (
                imageX + (imageWidth / 2) - 1,
                y + (imageHeight / 2) - 1,
                image.Width,
                image.Height - 1
            );

            using(ImageAttributes imageAttributes = new ImageAttributes())
            {
                imageAttributes.SetColorKey(Color.Magenta, Color.Magenta);

                ColorMap colorMap = new ColorMap();

                colorMap.OldColor = Color.FromArgb(0, 60, 166);
                colorMap.NewColor = color;

                imageAttributes.SetRemapTable(new ColorMap[] { colorMap });

                graphics.DrawImage(image, targetRectangle, 0, 0, imageWidth, imageHeight, GraphicsUnit.Pixel, imageAttributes);
            }
        }

        #endregion

        #region ̹  ؽƮ ׸ - DrawImageAndText(graphics, captionRectangle, captionSpacing, imageRectangle, image, rightToLeft, captionFont, captionColor, captionText)

        /// <summary>
        /// ̹  ؽƮ ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="captionRectangle"> 簢</param>
        /// <param name="captionSpacing"> </param>
        /// <param name="imageRectangle">̹ 簢</param>
        /// <param name="image">̹</param>
        /// <param name="rightToLeft">ʡ  </param>
        /// <param name="captionFont"> Ʈ</param>
        /// <param name="captionColor"> </param>
        /// <param name="captionText"> ؽƮ</param>
        protected static void DrawImageAndText(Graphics graphics, Rectangle captionRectangle, int captionSpacing, Rectangle imageRectangle, Image image, RightToLeft rightToLeft, Font captionFont, Color captionColor, string captionText)
        {
            int textX1 = captionSpacing;
            int textX2 = captionRectangle.Right - captionSpacing;

            imageRectangle.Y = (captionRectangle.Height - imageRectangle.Height) / 2;
            
            if(rightToLeft == RightToLeft.No)
            {
                if(image != null)
                {
                    DrawImage(graphics, image, imageRectangle);

                    textX1 += imageRectangle.Width + captionSpacing;
                }
            }

            Rectangle textRectangle = captionRectangle;

            textRectangle.X     =  textX1;
            textRectangle.Width -= textX1 + captionSpacing;

            if(rightToLeft == RightToLeft.Yes)
            {
                if(image != null)
                {
                    Rectangle rightToLeftRectangle = imageRectangle;

                    rightToLeftRectangle.X = textX2 - imageRectangle.Width;

                    DrawImage(graphics, image, rightToLeftRectangle);

                    textX2 = rightToLeftRectangle.X - captionSpacing;
                }
            }

            textRectangle.Width = textX2 - textX1;

            DrawString(graphics, textRectangle, captionFont, captionColor, captionText, rightToLeft, StringAlignment.Near);
        }

        #endregion
        #region ̹  ؽƮ ׸ - DrawImageAndText(graphics, captionRectangle, captionSpacing, imageRectangle, image, rightToLeft, isClosable, showCloseButton, closeButtonImage, closeButtonColor, closeButtonImageRectangle, showExpandButton, expandButtonImage, expandButtonColor, expandButtonImageRectangle, captionFont, captionColor, captionText)

        /// <summary>
        /// ̹  ؽƮ ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="captionRectangle"> 簢</param>
        /// <param name="captionSpacing"> </param>
        /// <param name="imageRectangle">̹ 簢</param>
        /// <param name="image">̹</param>
        /// <param name="rightToLeft">ʡ  </param>
        /// <param name="isClosable">ݱ  </param>
        /// <param name="showCloseButton">ݱ ư ǥ </param>
        /// <param name="closeButtonImage">ݱ ư ̹</param>
        /// <param name="closeButtonColor">ݱ ư </param>
        /// <param name="closeButtonImageRectangle">ݱ ư ̹ 簢</param>
        /// <param name="showExpandButton">Ȯ ư ǥ </param>
        /// <param name="expandButtonImage">Ȯ ư ̹</param>
        /// <param name="expandButtonColor">Ȯ ư </param>
        /// <param name="expandButtonImageRectangle">Ȯ ư ̹ 簢</param>
        /// <param name="captionFont"> Ʈ</param>
        /// <param name="captionColor"> </param>
        /// <param name="captionText"> ؽƮ</param>
        protected static void DrawImageAndText(Graphics graphics, Rectangle captionRectangle, int captionSpacing, Rectangle imageRectangle, Image image, RightToLeft rightToLeft, bool isClosable, bool showCloseButton, Image closeButtonImage, Color closeButtonColor, ref Rectangle closeButtonImageRectangle, bool showExpandButton, Image expandButtonImage, Color expandButtonColor, ref Rectangle expandButtonImageRectangle, Font captionFont, Color captionColor, string captionText)
        {
            int textX1 = captionSpacing;
            int textX2 = captionRectangle.Right - captionSpacing;

            imageRectangle.Y = (captionRectangle.Height - imageRectangle.Height) / 2;

            if(rightToLeft == RightToLeft.No)
            {
                if(image != null)
                {
                    DrawImage(graphics, image, imageRectangle);

                    textX1 += imageRectangle.Width + captionSpacing;
                    textX2 -= textX1;
                }
            }
            else
            {
                if((showCloseButton == true) && (closeButtonImage != null))
                {
                    closeButtonImageRectangle = imageRectangle;

                    closeButtonImageRectangle.X = imageRectangle.X;

                    if(isClosable == true)
                    {
                        DrawImage(graphics, closeButtonImage, closeButtonImageRectangle, closeButtonColor, imageRectangle.Y);
                    }

                    textX1 = closeButtonImageRectangle.X + closeButtonImageRectangle.Width;
                }

                if((showExpandButton == true) && (expandButtonImage != null))
                {
                    expandButtonImageRectangle = imageRectangle;

                    expandButtonImageRectangle.X = imageRectangle.X;

                    if((showCloseButton == true) && (closeButtonImage != null))
                    {
                        expandButtonImageRectangle.X = textX1 + (captionSpacing / 2);
                    }

                    DrawImage(graphics, expandButtonImage, expandButtonImageRectangle, expandButtonColor, imageRectangle.Y);

                    textX1 = expandButtonImageRectangle.X + expandButtonImageRectangle.Width;
                }
            }

            RectangleF textRectangle = captionRectangle;

            textRectangle.X     =  textX1;
            textRectangle.Width -= textX1 + captionSpacing;

            if(rightToLeft == RightToLeft.No)
            {
                if((showCloseButton == true) && (closeButtonImage != null))
                {
                    closeButtonImageRectangle = imageRectangle;

                    closeButtonImageRectangle.X = captionRectangle.Right - captionSpacing - imageRectangle.Width;

                    if(isClosable == true)
                    {
                        DrawImage(graphics, closeButtonImage, closeButtonImageRectangle, closeButtonColor, imageRectangle.Y);
                    }

                    textX2 = closeButtonImageRectangle.X;
                }

                if((showExpandButton == true) && (expandButtonImage != null))
                {
                    expandButtonImageRectangle = imageRectangle;

                    expandButtonImageRectangle.X = captionRectangle.Right - captionSpacing - imageRectangle.Width;

                    if((showCloseButton == true) && (closeButtonImage != null))
                    {
                        expandButtonImageRectangle.X = textX2 - (captionSpacing / 2) - imageRectangle.Width;
                    }

                    DrawImage(graphics, expandButtonImage, expandButtonImageRectangle, expandButtonColor, imageRectangle.Y);

                    textX2 = expandButtonImageRectangle.X;
                }

                if((showCloseButton == true) && (closeButtonImage != null) && (showExpandButton == true) && (expandButtonImage != null))
                {
                    textX2 -= captionSpacing;
                }
            }
            else
            {
                if(image != null)
                {
                    Rectangle rightToLeftRectangle = imageRectangle;

                    rightToLeftRectangle.X = textX2 - imageRectangle.Width;

                    DrawImage(graphics, image, rightToLeftRectangle);

                    textX2 = rightToLeftRectangle.X - captionSpacing;
                }
            }

            textRectangle.Width  = textX2 - textX1;
            textRectangle.Y      = (float)(captionRectangle.Height - captionFont.Height) / 2 + 1;
            textRectangle.Height = captionFont.Height;

            DrawString(graphics, textRectangle, captionFont, captionColor, captionText, rightToLeft, StringAlignment.Near);

            if(isClosable == false)
            {
                closeButtonImageRectangle = Rectangle.Empty;
            }
        }

        #endregion
        #region ̹  ؽƮ ׸ - DrawImageAndText(graphics, dockStyle, captionSpacing, captionRectangle, panelRectangle, imageRectangle, image, rightToLeft, showCloseButton, closeButtonImage, closeButtonColor, closeButtonImageRectangle, showExpandButton, expanded, expandButtonImage, expandButtonColor, expandButtonImageRectangle, captionFont, captionColor, collapsedColor, captionText)

        /// <summary>
        /// ̹  ؽƮ ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="dockStyle">ŷ Ÿ</param>
        /// <param name="captionSpacing"> </param>
        /// <param name="captionRectangle"> 簢</param>
        /// <param name="panelRectangle">г 簢</param>
        /// <param name="imageRectangle">̹ 簢</param>
        /// <param name="image">̹</param>
        /// <param name="rightToLeft">ʡ  </param>
        /// <param name="showCloseButton">ݱ ư ǥ </param>
        /// <param name="closeButtonImage">ݱ ư ̹</param>
        /// <param name="closeButtonColor">ݱ ư </param>
        /// <param name="closeButtonImageRectangle">ݱ ư ̹ 簢</param>
        /// <param name="showExpandButton">Ȯ ư ǥ </param>
        /// <param name="expanded">Ȯ </param>
        /// <param name="expandButtonImage">Ȯ ư ̹</param>
        /// <param name="expandButtonColor">Ȯ ư </param>
        /// <param name="expandButtonImageRectangle">Ȯ ư ̹ 簢</param>
        /// <param name="captionFont"> Ʈ</param>
        /// <param name="captionColor"> </param>
        /// <param name="collapsedColor">ҽ </param>
        /// <param name="captionText"> ؽƮ</param>
        protected static void DrawImageAndText(Graphics graphics, DockStyle dockStyle, int captionSpacing, Rectangle captionRectangle, Rectangle panelRectangle, Rectangle imageRectangle, Image image, RightToLeft rightToLeft, bool showCloseButton, Image closeButtonImage, Color closeButtonColor, ref Rectangle closeButtonImageRectangle, bool showExpandButton, bool expanded, Image expandButtonImage, Color expandButtonColor, ref Rectangle expandButtonImageRectangle, Font captionFont, Color captionColor, Color collapsedColor, string captionText)
        {
            switch(dockStyle)
            {
                case DockStyle.Left  :
                case DockStyle.Right :

                    if(expanded == true)
                    {
                        DrawImageAndText
                        (
                            graphics,
                            captionRectangle,
                            captionSpacing,
                            imageRectangle,
                            image,
                            rightToLeft,
                            true,
                            showCloseButton,
                            closeButtonImage,
                            closeButtonColor,
                            ref closeButtonImageRectangle,
                            showExpandButton,
                            expandButtonImage,
                            expandButtonColor,
                            ref expandButtonImageRectangle,
                            captionFont,
                            captionColor,
                            captionText
                        );
                    }
                    else
                    {
                        closeButtonImageRectangle = Rectangle.Empty;

                        DrawVerticalImageAndText
                        (
                            graphics,
                            captionRectangle,
                            panelRectangle,
                            imageRectangle,
                            dockStyle,
                            image,
                            rightToLeft,
                            expandButtonImage,
                            expandButtonColor,
                            ref expandButtonImageRectangle,
                            captionFont,
                            collapsedColor,
                            captionText
                        );
                    }

                    break;

                case DockStyle.Top    :
                case DockStyle.Bottom :

                    DrawImageAndText
                    (
                        graphics,
                        captionRectangle,
                        captionSpacing,
                        imageRectangle,
                        image,
                        rightToLeft,
                        true,
                        showCloseButton,
                        closeButtonImage,
                        closeButtonColor,
                        ref closeButtonImageRectangle,
                        showExpandButton,
                        expandButtonImage,
                        expandButtonColor,
                        ref expandButtonImageRectangle,
                        captionFont,
                        captionColor,
                        captionText
                    );

                    break;
            }
        }

        #endregion

        #region г  ĥϱ - RenderPanelBackground(graphics, boundRectangle, beginColor, endColor, linearGradientMode)

        /// <summary>
        /// г  ĥϱ
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="boundRectangle"> 簢</param>
        /// <param name="beginColor"> </param>
        /// <param name="endColor"> </param>
        /// <param name="linearGradientMode"> ׶Ʈ </param>
        protected static void RenderPanelBackground(Graphics graphics, Rectangle boundRectangle, Color beginColor, Color endColor, LinearGradientMode linearGradientMode)
        {
            if(graphics == null)
            {
                throw new ArgumentException
                (
                    string.Format
                    (
                        CultureInfo.CurrentUICulture,
                        ConstantHelper.ARGUMENT_EXCAPTION_MESSAGE,
                        typeof(Graphics).Name
                    )
                );
            }

            if(IsZeroWidthOrHeight(boundRectangle))
            {
                return;
            }

            using(LinearGradientBrush linearGradientBrush = new LinearGradientBrush(boundRectangle, beginColor, endColor, linearGradientMode))
            {
                graphics.FillRectangle(linearGradientBrush, boundRectangle);
            }
        }

        #endregion
        #region    ĥϱ - RenderCaptionBarBackground(graphics, boundRectangle, beginColor, middleColor, endColor, linearGradientMode, flipHorizontal)

        /// <summary>
        ///    ĥϱ
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="boundRectangle"> 簢</param>
        /// <param name="beginColor"> </param>
        /// <param name="middleColor">߰ </param>
        /// <param name="endColor"> </param>
        /// <param name="linearGradientMode"> ׶Ʈ </param>
        /// <param name="flipHorizontal">  </param>
        protected static void RenderCaptionBarBackground(Graphics graphics, Rectangle boundRectangle, Color beginColor, Color middleColor, Color endColor, LinearGradientMode linearGradientMode, bool flipHorizontal)
        {
            int upperHeight = boundRectangle.Height / 2;
            int lowerHeight = boundRectangle.Height - upperHeight;

            RenderCaptionBarBackground
            (
                graphics,
                boundRectangle,
                beginColor,
                middleColor,
                endColor,
                upperHeight,
                lowerHeight,
                linearGradientMode,
                flipHorizontal
            );
        }

        #endregion
        #region ư  ĥϱ - RenderButtonBackground(graphics, boundRectangle, beginColor, middleColor, endColor)

        /// <summary>
        /// ư  ĥϱ
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="boundRectangle"> 簢</param>
        /// <param name="beginColor"> </param>
        /// <param name="middleColor">߰ </param>
        /// <param name="endColor"> </param>
        protected static void RenderButtonBackground(Graphics graphics, Rectangle boundRectangle, Color beginColor, Color middleColor, Color endColor)
        {
            RectangleF upperRectangle = boundRectangle;

            upperRectangle.Height = boundRectangle.Height * 0.4f;

            using(LinearGradientBrush upperLinearGradientBrush = new LinearGradientBrush(upperRectangle, beginColor, middleColor, LinearGradientMode.Vertical))
            {
                if(upperLinearGradientBrush != null)
                {
                    Blend blend = new Blend();

                    blend.Positions = new float[] { 0.0F, 1.0F };
                    blend.Factors   = new float[] { 0.0F, 0.6F };

                    upperLinearGradientBrush.Blend = blend;

                    graphics.FillRectangle(upperLinearGradientBrush, upperRectangle);
                }
            }

            RectangleF lowerRectangle = boundRectangle;

            lowerRectangle.Y      = upperRectangle.Height;
            lowerRectangle.Height = boundRectangle.Height - upperRectangle.Height;

            using(LinearGradientBrush lowerLinearGradientBrush = new LinearGradientBrush(lowerRectangle, middleColor, endColor, LinearGradientMode.Vertical))
            {
                if(lowerLinearGradientBrush != null)
                {
                    graphics.FillRectangle(lowerLinearGradientBrush, lowerRectangle);
                }
            }

            RectangleF correctionRectangle = lowerRectangle;

            correctionRectangle.Y      -= 1;
            correctionRectangle.Height =  2;

            using(SolidBrush solidBrush = new SolidBrush(middleColor))
            {
                graphics.FillRectangle(solidBrush, correctionRectangle);
            }
        }

        #endregion
        #region ÷ ư  ĥϱ - RenderFlatButtonBackground(graphics, boundRectangle, beginColor, endColor, isHover)

        /// <summary>
        /// ÷ ư  ĥϱ
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="boundRectangle"> 簢</param>
        /// <param name="beginColor"> </param>
        /// <param name="endColor"> </param>
        /// <param name="isHover">ȣ </param>
        protected static void RenderFlatButtonBackground(Graphics graphics, Rectangle boundRectangle, Color beginColor, Color endColor, bool isHover)
        {
            using(LinearGradientBrush gradientBrush = GetFlatExpanderPanelCaptionBrush(boundRectangle, beginColor, endColor, isHover))
            {
                if(gradientBrush != null)
                {
                    graphics.FillRectangle(gradientBrush, boundRectangle);
                }
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region    ĥϱ - RenderCaptionBarBackground(graphics, boundRectangle, beginColor, middleColor, endColor, firstGradientWidth, secondGradientWidth, linearGradientMode, flipHorizontal)

        /// <summary>
        ///    ĥϱ
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="boundRectangle"> 簢</param>
        /// <param name="beginColor"> </param>
        /// <param name="middleColor">߰ </param>
        /// <param name="endColor"> </param>
        /// <param name="firstGradientWidth">ù° ׶Ʈ ʺ</param>
        /// <param name="secondGradientWidth">ι° ׶Ʈ ʺ</param>
        /// <param name="linearGradientMode"> ׶Ʈ </param>
        /// <param name="flipHorizontal">  </param>
        private static void RenderCaptionBarBackground(Graphics graphics, Rectangle boundRectangle, Color beginColor, Color middleColor, Color endColor, int firstGradientWidth, int secondGradientWidth, LinearGradientMode linearGradientMode, bool flipHorizontal)
        {
            if((boundRectangle.Width != 0) && (boundRectangle.Height != 0))
            {
                Rectangle rectangle1 = boundRectangle;
                Rectangle rectangle2 = boundRectangle;

                bool flag1 = true;

                if(linearGradientMode == LinearGradientMode.Horizontal)
                {
                    if(flipHorizontal)
                    {
                        Color color1 = endColor;

                        endColor   = beginColor;
                        beginColor = color1;
                    }

                    rectangle2.Width = firstGradientWidth;
                    rectangle1.Width = secondGradientWidth + 1;

                    rectangle1.X = boundRectangle.Right - rectangle1.Width;

                    flag1 = boundRectangle.Width > (firstGradientWidth + secondGradientWidth);
                }
                else
                {
                    rectangle2.Height = firstGradientWidth;
                    rectangle1.Height = secondGradientWidth + 1;

                    rectangle1.Y = boundRectangle.Bottom - rectangle1.Height;

                    flag1 = boundRectangle.Height > (firstGradientWidth + secondGradientWidth);
                }

                if(flag1)
                {
                    using(Brush brush1 = new SolidBrush(middleColor))
                    {
                        graphics.FillRectangle(brush1, boundRectangle);
                    }

                    using(Brush brush2 = new LinearGradientBrush(rectangle2, beginColor, middleColor, linearGradientMode))
                    {
                        graphics.FillRectangle(brush2, rectangle2);
                    }

                    using(LinearGradientBrush brush3 = new LinearGradientBrush(rectangle1, middleColor, endColor, linearGradientMode))
                    {
                        if(linearGradientMode == LinearGradientMode.Horizontal)
                        {
                            rectangle1.X++;
                            rectangle1.Width--;
                        }
                        else
                        {
                            rectangle1.Y++;
                            rectangle1.Height--;
                        }

                        graphics.FillRectangle(brush3, rectangle1);

                        return;
                    }
                }

                using(Brush brush4 = new LinearGradientBrush(boundRectangle, beginColor, endColor, linearGradientMode))
                {
                    graphics.FillRectangle(brush4, boundRectangle);
                }
            }
        }

        #endregion
        #region  ̹  ؽƮ ׸ - DrawVerticalImageAndText(graphics, captionRectangle, panelRectangle, imageRectangle, dockStyle, image, rightToLeft, expandButtonImage, expandButtonColor, expandButtonImageRectangle, captionFont, captionColor, captionText)

        /// <summary>
        ///  ̹  ؽƮ ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="captionRectangle"> 簢</param>
        /// <param name="panelRectangle">г 簢</param>
        /// <param name="imageRectangle">̹ 簢</param>
        /// <param name="dockStyle">ŷ Ÿ</param>
        /// <param name="image">̹</param>
        /// <param name="rightToLeft">ʡ  </param>
        /// <param name="expandButtonImage">Ȯ ư ̹</param>
        /// <param name="expandButtonColor">Ȯ ư </param>
        /// <param name="expandButtonImageRectangle">Ȯ ư ̹ 簢</param>
        /// <param name="captionFont"> Ʈ</param>
        /// <param name="captionColor"> </param>
        /// <param name="captionText"> ؽƮ</param>
        private static void DrawVerticalImageAndText(Graphics graphics, Rectangle captionRectangle, Rectangle panelRectangle, Rectangle imageRectangle, DockStyle dockStyle, Image image, RightToLeft rightToLeft, Image expandButtonImage, Color expandButtonColor, ref Rectangle expandButtonImageRectangle, Font captionFont, Color captionColor, string captionText)
        {
            imageRectangle.Y = (captionRectangle.Height - imageRectangle.Height) / 2;
            
            if(expandButtonImage != null)
            {
                expandButtonImageRectangle = imageRectangle;

                expandButtonImageRectangle.X = (panelRectangle.Width - imageRectangle.Width) / 2;

                DrawImage(graphics, expandButtonImage, expandButtonImageRectangle, expandButtonColor, imageRectangle.Y);
            }

            int iTextPositionY1 = CAPTION_SPACING;
            int iTextPositionY2 = panelRectangle.Height - CAPTION_SPACING;

            if(image != null)
            {
                imageRectangle.Y = iTextPositionY2 - imageRectangle.Height;
                imageRectangle.X = (panelRectangle.Width - imageRectangle.Width) / 2;

                DrawImage(graphics, image, imageRectangle);

                iTextPositionY1 += imageRectangle.Height + CAPTION_SPACING;
            }

            iTextPositionY2 -= captionRectangle.Height + iTextPositionY1;
            
            Rectangle textRectangle = new Rectangle
            (
                iTextPositionY1,
                panelRectangle.Y,
                iTextPositionY2,
                captionRectangle.Height
            );

            using(SolidBrush textBrush = new SolidBrush(captionColor))
            {
                if(dockStyle == DockStyle.Left)
                {
                    graphics.TranslateTransform(0, panelRectangle.Height);

                    graphics.RotateTransform(-90);

                    DrawString
                    (
                        graphics,
                        textRectangle,
                        captionFont,
                        captionColor,
                        captionText,
                        rightToLeft,
                        StringAlignment.Center
                    );

                    graphics.ResetTransform();
                }

                if(dockStyle == DockStyle.Right)
                {
                    graphics.TranslateTransform(panelRectangle.Width, 0);

                    graphics.RotateTransform(90);

                    DrawString
                    (
                        graphics,
                        textRectangle,
                        captionFont,
                        captionColor,
                        captionText,
                        rightToLeft,
                        StringAlignment.Center
                    );

                    graphics.ResetTransform();
                }
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region г  ϱ - SetPanelColor(panelColor)

        /// <summary>
        /// г  ϱ
        /// </summary>
        /// <param name="panelColor">г </param>
        public virtual void SetPanelColor(PanelColor panelColor)
        {
            if(panelColor == null)
            {
                throw new ArgumentException
                (
                    string.Format
                    (
                        CultureInfo.CurrentUICulture,
                        ConstantHelper.ARGUMENT_EXCAPTION_MESSAGE,
                        "panelColor"
                    )
                );
            }

            this.panelColor = panelColor;

            ColorScheme = ColorScheme.Professional;

            Invalidate(true);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Protected

        #region 콺 ̵ óϱ - OnMouseMove(e)

        /// <summary>
        /// 콺 ̵ óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnMouseMove(MouseEventArgs e)
        {
            if(CaptionRectangle.Contains(e.X, e.Y) == true)
            {
                if(this.captionBarHoverState == HoverState.None)
                {
                    this.captionBarHoverState = HoverState.Hover;

                    OnCaptionBarHoverStateChanged(this, new HoverStateChangedEventArgs(this.captionBarHoverState));
                }
            }
            else
            {
                if(this.captionBarHoverState == HoverState.Hover)
                {
                    this.captionBarHoverState = HoverState.None;

                    OnCaptionBarHoverStateChanged(this, new HoverStateChangedEventArgs(this.captionBarHoverState));
                }
            }

            if((ShowExpandButton == true) || (ShowCloseButton == true))
            {
                if(ExpandButtonRectangle.Contains(e.X, e.Y) == true)
                {
                    if(this.expandButtonHoverState == HoverState.None)
                    {
                        this.expandButtonHoverState = HoverState.Hover;

                        OnExpandButtonHoverStateChanged(this, new HoverStateChangedEventArgs(this.expandButtonHoverState));
                    }
                }
                else
                {
                    if(this.expandButtonHoverState == HoverState.Hover)
                    {
                        this.expandButtonHoverState = HoverState.None;

                        OnExpandButtonHoverStateChanged(this, new HoverStateChangedEventArgs(this.expandButtonHoverState));
                    }
                }

                if(this.CloseButtonRectangle.Contains(e.X, e.Y) == true)
                {
                    if(this.closeButtonHoverState == HoverState.None)
                    {
                        this.closeButtonHoverState = HoverState.Hover;

                        OnCloseButtonHoverStateChanged(this, new HoverStateChangedEventArgs(this.closeButtonHoverState));
                    }
                }
                else
                {
                    if(this.closeButtonHoverState == HoverState.Hover)
                    {
                        this.closeButtonHoverState = HoverState.None;

                        OnCloseButtonHoverStateChanged(this, new HoverStateChangedEventArgs(this.closeButtonHoverState));
                    }
                }
            }

            base.OnMouseMove(e);
        }

        #endregion
        #region 콺 UP óϱ - OnMouseUp(e)

        /// <summary>
        /// 콺 UP óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnMouseUp(MouseEventArgs e)
        {
            if((ShowExpandButton == true) && (ExpandButtonRectangle.Contains(e.X, e.Y) == true))
            {
                OnExpandButtonClick(this, EventArgs.Empty);
            }

            if((ShowCloseButton == true) && (CloseButtonRectangle.Contains(e.X, e.Y) == true))
            {
                OnCloseButtonClick(this, EventArgs.Empty);
            }

            base.OnMouseUp(e);
        }

        #endregion
        #region 콺 Ż óϱ - OnMouseLeave(e)

        /// <summary>
        /// 콺 Ż óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnMouseLeave(EventArgs e)
        {
            if(this.captionBarHoverState == HoverState.Hover)
            {
                this.captionBarHoverState = HoverState.None;

                OnCaptionBarHoverStateChanged(this, new HoverStateChangedEventArgs(this.captionBarHoverState));
            }

            if(this.expandButtonHoverState == HoverState.Hover)
            {
                this.expandButtonHoverState = HoverState.None;

                OnExpandButtonHoverStateChanged(this, new HoverStateChangedEventArgs(this.expandButtonHoverState));
            }

            if(this.closeButtonHoverState == HoverState.Hover)
            {
                this.closeButtonHoverState = HoverState.None;

                OnCloseButtonHoverStateChanged(this, new HoverStateChangedEventArgs(this.closeButtonHoverState));
            }

            base.OnMouseLeave(e);
        }

        #endregion

        #region г Ÿ  óϱ - OnPanelStyleChanged(sender, e)

        /// <summary>
        /// г Ÿ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void OnPanelStyleChanged(object sender, PanelStyleChangedEventArgs e)
        {
            PanelStyle panelStyle = e.PanelStyle;

            switch(panelStyle)
            {
                case PanelStyle.Default    : this.panelColor = new PanelColor(this);                break;
                case PanelStyle.Office2007 : this.panelColor = new Office2007BluePanelColor(this); break;
            }

            Invalidate(true);

            PanelStyleChanged?.Invoke(sender, e);
        }

        #endregion
        #region  Ŵ  óϱ - OnColorSchemeChanged(sender, e)

        /// <summary>
        ///  Ŵ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void OnColorSchemeChanged(object sender, ColorSchemeChangedEventArgs e)
        {
            PanelColor.Clear();

            Invalidate(false);

            ColorSchemeChanged?.Invoke(sender, e);
        }

        #endregion
        #region Ŀ   óϱ - OnCustomColorChanged(sender, e)

        /// <summary>
        /// Ŀ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void customColor_CustomColorChanged(object sender, EventArgs e)
        {
            if(ColorScheme == ColorScheme.Custom)
            {
                PanelColor.Clear();

                Invalidate(false);
            }

            CustomColorsChanged?.Invoke(sender, e);
        }

        #endregion
        #region    óϱ - OnCaptionHeightChanged(sender, e)

        /// <summary>
        ///    óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void OnCaptionHeightChanged(object sender, EventArgs e)
        {
            OnLayout(new LayoutEventArgs(this, null));

            Invalidate(false);

            CaptionHeightChanged?.Invoke(sender, e);
        }

        #endregion
        #region   ȣ   óϱ - OnCaptionBarHoverStateChanged(sender, e)

        /// <summary>
        ///   ȣ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void OnCaptionBarHoverStateChanged(object sender, HoverStateChangedEventArgs e)
        {
            if(this is ExpanderPanel)
            {
                if(e.HoverState == HoverState.Hover)
                {
                    if((ShowCloseButton == false) && (ShowExpandButton == false))
                    {
                        if(Cursor != Cursors.Hand)
                        {
                            Cursor = Cursors.Hand;
                        }
                    }
                }
                else
                {
                    if(Cursor == Cursors.Hand)
                    {
                        Cursor = Cursors.Default;
                    }
                }

                Invalidate(CaptionRectangle);
            }

            CaptionBarHoverStateChanged?.Invoke(sender, e);
        }

        #endregion
        #region ؽƮ  óϱ - OnTextChanged(e)

        /// <summary>
        /// ؽƮ  óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnTextChanged(EventArgs e)
        {
            Invalidate(CaptionRectangle);

            base.OnTextChanged(e);
        }

        #endregion
        #region Ȯ ư ȣ   óϱ - OnExpandButtonHoverStateChanged(sender, e)

        /// <summary>
        /// Ȯ ư ȣ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void OnExpandButtonHoverStateChanged(object sender, HoverStateChangedEventArgs e)
        {
            if(e.HoverState == HoverState.Hover)
            {
                if(Cursor != Cursors.Hand)
                {
                    Cursor = Cursors.Hand;

                    if(Expanded == true)
                    {
                        if(this is Panel)
                        {
                            if(string.IsNullOrEmpty(this.expandButtonToolTipText2) == false)
                            {
                                this.toolTip.SetToolTip(this, this.expandButtonToolTipText2);
                            }
                        }
                    }
                    else
                    {
                        if(string.IsNullOrEmpty(this.expandButtonToolTipText1) == false)
                        {
                            this.toolTip.SetToolTip(this, this.expandButtonToolTipText1);
                        }
                    }
                }
            }
            else
            {
                if(Cursor == Cursors.Hand)
                {
                    this.toolTip.SetToolTip(this, string.Empty);

                    this.toolTip.Hide(this);

                    Cursor = Cursors.Default;
                }
            }

            ExpandButtonHoverStateChanged?.Invoke(sender, e);
        }

        #endregion
        #region Ȯ ư Ŭ óϱ - OnExpandButtonClick(sender, e)

        /// <summary>
        /// Ȯ ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void OnExpandButtonClick(object sender, EventArgs e)
        {
            Invalidate(false);

            ExpandButtonClick?.Invoke(sender, e);
        }

        #endregion
        #region ݱ ư ȣ   óϱ - OnCloseButtonHoverStateChanged(sender, e)

        /// <summary>
        /// ݱ ư ȣ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void OnCloseButtonHoverStateChanged(object sender, HoverStateChangedEventArgs e)
        {
            if(e.HoverState == HoverState.Hover)
            {
                if(Cursor != Cursors.Hand)
                {
                    Cursor = Cursors.Hand;
                }

                if(string.IsNullOrEmpty(this.closeButtonToolTipText) == false)
                {
                    this.toolTip.SetToolTip(this, this.closeButtonToolTipText);
                }
            }
            else
            {
                if(Cursor == Cursors.Hand)
                {
                    this.toolTip.SetToolTip(this, string.Empty);

                    this.toolTip.Hide(this);

                    Cursor = Cursors.Default;
                }
            }

            CloseButtonHoverStateChanged?.Invoke(sender, e);
        }

        #endregion
        #region ݱ ư Ŭ óϱ - OnCloseButtonClick(sender, e)

        /// <summary>
        /// ݱ ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void OnCloseButtonClick(object sender, EventArgs e)
        {
            CloseButtonClick?.Invoke(sender, e);
        }

        #endregion
        #region г ҽ óϱ - OnPanelCollapsed(sender, e)

        /// <summary>
        /// г ҽ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void OnPanelCollapsed(object sender, PanelStateChangedEventArgs e)
        {
            PanelCollapsed?.Invoke(sender, e);
        }

        #endregion
        #region г Ȯ óϱ - OnPanelExpanded(sender, e)

        /// <summary>
        /// г Ȯ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void OnPanelExpanded(object sender, PanelStateChangedEventArgs e)
        {
            PanelExpanded?.Invoke(sender, e);
        }

        #endregion
    }
}