﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 익스팬더 패널 커스텀 색상
    /// </summary>
    public class ExpanderPanelCustomColor : CustomColor
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 배경색
        /// </summary>
        private Color backgroundColor = SystemColors.Control;

        /// <summary>
        /// 제목 바 플랫 시작 색상
        /// </summary>
        private Color captionBarFlatBeginColor = ProfessionalColors.ToolStripGradientMiddle;

        /// <summary>
        /// 제목 바 플랫 종료 색상
        /// </summary>
        private Color captionBarFlatEndColor = ProfessionalColors.ToolStripGradientBegin;

        /// <summary>
        /// 제목 바 PRESS 시작 색상
        /// </summary>
        private Color captionBarPressedBeginColor = ProfessionalColors.ButtonPressedGradientBegin;

        /// <summary>
        /// 제목 바 PRESS 중간 색상
        /// </summary>
        private Color captionBarPressedMiddleColor = ProfessionalColors.ButtonPressedGradientMiddle;

        /// <summary>
        /// 제목 바 PRESS 종료 색상
        /// </summary>
        private Color captionBarPressedEndColor = ProfessionalColors.ButtonPressedGradientEnd;

        /// <summary>
        /// 제목 바 체크 시작 색상
        /// </summary>
        private Color captionBarCheckedBeginColor = ProfessionalColors.ButtonCheckedGradientBegin;

        /// <summary>
        /// 제목 바 체크 중간 색상
        /// </summary>
        private Color captionBarCheckedMiddleColor = ProfessionalColors.ButtonCheckedGradientMiddle;

        /// <summary>
        /// 제목 바 체크 종료 색상
        /// </summary>
        private Color captionBarCheckedEndColor = ProfessionalColors.ButtonCheckedGradientEnd;

        /// <summary>
        /// 제목 바 선택 시작 색상
        /// </summary>
        private Color captionBarSelectedBeginColor = ProfessionalColors.ButtonSelectedGradientBegin;

        /// <summary>
        /// 제목 바 선택 중간 색상
        /// </summary>
        private Color captionBarSelectedMiddleColor = ProfessionalColors.ButtonSelectedGradientMiddle;

        /// <summary>
        /// 제목 바 선택 종료 색상
        /// </summary>
        private Color captionBarSelectedEndColor = ProfessionalColors.ButtonSelectedGradientEnd;

        /// <summary>
        /// 제목 텍스트 선택 색상
        /// </summary>
        private Color captionTextSelectedColor = SystemColors.ControlText;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 배경색 - BackgroundColor

        /// <summary>
        /// 배경색
        /// </summary>
        public virtual Color BackgroundColor
        {
            get
            {
                return this.backgroundColor;
            }
            set
            {
                if(value.Equals(this.backgroundColor) == false)
                {
                    this.backgroundColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 제목 바 플랫 시작 색상 - CaptionBarFlatBeginColor

        /// <summary>
        /// 제목 바 플랫 시작 색상
        /// </summary>
        public virtual Color CaptionBarFlatBeginColor
        {
            get
            {
                return this.captionBarFlatBeginColor;
            }
            set
            {
                if(value.Equals(this.captionBarFlatBeginColor) == false)
                {
                    this.captionBarFlatBeginColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 제목 바 플랫 종료 색상 - CaptionBarFlatEndColor

        /// <summary>
        /// 제목 바 플랫 종료 색상
        /// </summary>
        public virtual Color CaptionBarFlatEndColor
        {
            get
            {
                return this.captionBarFlatEndColor;
            }
            set
            {
                if(value.Equals(this.captionBarFlatEndColor) == false)
                {
                    this.captionBarFlatEndColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 제목 바 PRESS 시작 색상 - CaptionBarPressedBeginColor

        /// <summary>
        /// 제목 바 PRESS 시작 색상
        /// </summary>
        public virtual Color CaptionBarPressedBeginColor
        {
            get
            {
                return this.captionBarPressedBeginColor;
            }
            set
            {
                if(value.Equals(this.captionBarPressedBeginColor) == false)
                {
                    this.captionBarPressedBeginColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 제목 바 PRESS 중간 색상 - CaptionBarPressedMiddleColor

        /// <summary>
        /// 제목 바 PRESS 중간 색상
        /// </summary>
        public virtual Color CaptionBarPressedMiddleColor
        {
            get
            {
                return this.captionBarPressedMiddleColor;
            }
            set
            {
                if(value.Equals(this.captionBarPressedMiddleColor) == false)
                {
                    this.captionBarPressedMiddleColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 제목 바 PRESS 종료 색상 - CaptionBarPressedEndColor

        /// <summary>
        /// 제목 바 PRESS 종료 색상
        /// </summary>
        public virtual Color CaptionBarPressedEndColor
        {
            get
            {
                return this.captionBarPressedEndColor;
            }
            set
            {
                if(value.Equals(this.captionBarPressedEndColor) == false)
                {
                    this.captionBarPressedEndColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 제목 바 체크 시작 색상 - CaptionBarCheckedBeginColor

        /// <summary>
        /// 제목 바 체크 시작 색상
        /// </summary>
        public virtual Color CaptionBarCheckedBeginColor
        {
            get
            {
                return this.captionBarCheckedBeginColor;
            }
            set
            {
                if(value.Equals(this.captionBarCheckedBeginColor) == false)
                {
                    this.captionBarCheckedBeginColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 제목 바 체크 중간 색상 - CaptionBarCheckedMiddleColor

        /// <summary>
        /// 제목 바 체크 중간 색상
        /// </summary>
        public virtual Color CaptionBarCheckedMiddleColor
        {
            get
            {
                return this.captionBarCheckedMiddleColor;
            }
            set
            {
                if(value.Equals(this.captionBarCheckedMiddleColor) == false)
                {
                    this.captionBarCheckedMiddleColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 제목 바 체크 종료 색상 - CaptionBarCheckedEndColor

        /// <summary>
        /// 제목 바 체크 종료 색상
        /// </summary>
        public virtual Color CaptionBarCheckedEndColor
        {
            get
            {
                return this.captionBarCheckedEndColor;
            }
            set
            {
                if(value.Equals(this.captionBarCheckedEndColor) == false)
                {
                    this.captionBarCheckedEndColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 제목 바 선택 시작 색상 - CaptionBarSelectedBeginColor

        /// <summary>
        /// 제목 바 선택 시작 색상
        /// </summary>
        public virtual Color CaptionBarSelectedBeginColor
        {
            get
            {
                return this.captionBarSelectedBeginColor;
            }
            set
            {
                if(value.Equals(this.captionBarSelectedBeginColor) == false)
                {
                    this.captionBarSelectedBeginColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 제목 바 선택 중간 색상 - CaptionBarSelectedMiddleColor

        /// <summary>
        /// 제목 바 선택 중간 색상
        /// </summary>
        public virtual Color CaptionBarSelectedMiddleColor
        {
            get
            {
                return this.captionBarSelectedMiddleColor;
            }
            set
            {
                if(value.Equals(this.captionBarSelectedMiddleColor) == false)
                {
                    this.captionBarSelectedMiddleColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 제목 바 선택 종료 색상 - CaptionBarSelectedEndColor

        /// <summary>
        /// 제목 바 선택 종료 색상
        /// </summary>
        public virtual Color CaptionBarSelectedEndColor
        {
            get
            {
                return this.captionBarSelectedEndColor;
            }
            set
            {
                if(value.Equals(this.captionBarSelectedEndColor) == false)
                {
                    this.captionBarSelectedEndColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 제목 텍스트 선택 색상 - CaptionTextSelectedColor

        /// <summary>
        /// 제목 텍스트 선택 색상
        /// </summary>
        public virtual Color CaptionTextSelectedColor
        {
            get
            {
                return this.captionTextSelectedColor;
            }
            set
            {
                if(value.Equals(this.captionTextSelectedColor) == false)
                {
                    this.captionTextSelectedColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
    }
}