﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 패널 커스텀 색상
    /// </summary>
    public class PanelCustomColor : CustomColor
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 제목 바 선택 시작 색상
        /// </summary>
        private Color captionBarSelectedBeginColor = ProfessionalColors.ButtonSelectedGradientBegin;

        /// <summary>
        /// 제목 바 선택 종료 색상
        /// </summary>
        private Color captionBarSelectedEndColor = ProfessionalColors.ButtonSelectedGradientEnd;

        /// <summary>
        /// 제목 텍스트 축소시 색상
        /// </summary>
        private Color captionTextCollapsedColor = SystemColors.ControlText;

        /// <summary>
        /// 컨텐트 시작 색상
        /// </summary>
        private Color contentBeginColor = ProfessionalColors.ToolStripContentPanelGradientBegin;

        /// <summary>
        /// 컨텐트 종료 색상
        /// </summary>
        private Color contentEndColor = ProfessionalColors.ToolStripContentPanelGradientEnd;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 제목 바 선택 시작 색상 - CaptionBarSelectedBeginColor

        /// <summary>
        /// 제목 바 선택 시작 색상
        /// </summary>
        public virtual Color CaptionBarSelectedBeginColor
        {
            get
            {
                return this.captionBarSelectedBeginColor;
            }
            set
            {
                if(value.Equals(this.captionBarSelectedBeginColor) == false)
                {
                    this.captionBarSelectedBeginColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 제목 바 선택 종료 색상 - CaptionBarSelectedEndColor

        /// <summary>
        /// 제목 바 선택 종료 색상
        /// </summary>
        public virtual Color CaptionBarSelectedEndColor
        {
            get
            {
                return this.captionBarSelectedEndColor;
            }
            set
            {
                if(value.Equals(this.captionBarSelectedEndColor) == false)
                {
                    this.captionBarSelectedEndColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 제목 텍스트 축소시 색상 - CaptionTextCollapsedColor

        /// <summary>
        /// 제목 텍스트 축소시 색상
        /// </summary>
        public virtual Color CaptionTextCollapsedColor
        {
            get
            {
                return this.captionTextCollapsedColor;
            }
            set
            {
                if(value.Equals(this.captionTextCollapsedColor) == false)
                {
                    this.captionTextCollapsedColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 컨텐트 시작 색상 - ContentBeginColor

        /// <summary>
        /// 컨텐트 시작 색상
        /// </summary>
        public virtual Color ContentBeginColor
        {
            get
            {
                return this.contentBeginColor;
            }
            set
            {
                if(value.Equals(this.contentBeginColor) == false)
                {
                    this.contentBeginColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
        #region 컨텐트 종료 색상 - ContentEndColor

        /// <summary>
        /// 컨텐트 종료 색상
        /// </summary>
        public virtual Color ContentEndColor
        {
            get
            {
                return this.contentEndColor;
            }
            set
            {
                if(value.Equals(this.contentEndColor) == false)
                {
                    this.contentEndColor = value;

                    OnCustomColorChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
    }
}