using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

using TestProject.Properties;

namespace TestProject
{
    /// <summary>
    /// ͽҴ г
    /// </summary>
    [Designer(typeof(ExpanderPanelDesigner))]
    [DesignTimeVisible(false)]
	public partial class ExpanderPanel : BasePanel
	{
        //////////////////////////////////////////////////////////////////////////////////////////////////// Event
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  Ÿ  ̺Ʈ - CaptionStyleChanged

        /// <summary>
        ///  Ÿ  ̺Ʈ
        /// </summary>
        public event EventHandler<EventArgs> CaptionStyleChanged;

        #endregion
		
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

		#region Field
		
        /// <summary>
        /// Ŀ 
        /// </summary>
        private ExpanderPanelCustomColor customColor;

        /// <summary>
        ///  Ÿ
        /// </summary>
        private CaptionStyle captionStyle;

        /// <summary>
        /// κ귱 ̹
        /// </summary>
		private Image chevronImage;

        /// <summary>
        /// κ귱 UP ̹
        /// </summary>
        private Image chevronUpImage;

        /// <summary>
        /// κ귱 DOWN ̹
        /// </summary>
        private Image chevronDownImage;

        /// <summary>
        /// ݱ  
        /// </summary>
        private bool isClosable = true;

        /// <summary>
        /// ݱ ư ̹
        /// </summary>
        private Image closeButtonImage;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ũ - Size

        /// <summary>
        /// ũ
        /// </summary>
        [Browsable(false)]
        public new Size Size
        {
            get
            {
                return base.Size;
            }
            set
            {
                base.Size = value;
            }
        }

        #endregion
        #region ÷ 簢 - DisplayRectangle

        /// <summary>
        /// ÷ 簢
        /// </summary>
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override Rectangle DisplayRectangle
        {
            get
            {
                Padding padding = Padding;

                Rectangle displayRectangle = new Rectangle
                (
                    padding.Left + ConstantHelper.BORDER_THICKNESS,
                    padding.Top + this.CaptionHeight,
                    this.ClientRectangle.Width - padding.Left - padding.Right - (2 * ConstantHelper.BORDER_THICKNESS),
                    this.ClientRectangle.Height - this.CaptionHeight - padding.Top - padding.Bottom
                );

                if(Controls.Count > 0)
                {
                    ExpanderPanelList expanderPanelList = Controls[0] as ExpanderPanelList;

                    if((expanderPanelList != null) && (expanderPanelList.Dock == DockStyle.Fill))
                    {
                        displayRectangle = new Rectangle
                        (
                            padding.Left,
                            padding.Top + this.CaptionHeight,
                            this.ClientRectangle.Width - padding.Left - padding.Right,
                            this.ClientRectangle.Height - this.CaptionHeight - padding.Top - padding.Bottom - ConstantHelper.BORDER_THICKNESS
                        );
                    }
                }

                return displayRectangle;
            }
        }

        #endregion
        #region Ŀ  - CustomColor

        /// <summary>
        /// Ŀ 
        /// </summary>
        [Category(nameof(ExpanderPanel))]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
        public ExpanderPanelCustomColor CustomColor
        {
            get
            {
                return this.customColor;
            }
        }

        #endregion
        #region  Ÿ - CaptionStyle

        /// <summary>
        ///  Ÿ
        /// </summary>
        [Browsable(false)]
        [DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden)]
        public CaptionStyle CaptionStyle
        {
            get
            {
                return this.captionStyle;
            }
            set
            {
                if(value.Equals(this.captionStyle) == false)
                {
                    this.captionStyle = value;

                    OnCaptionStyleChanged(this, EventArgs.Empty);
                }
            }
        }

        #endregion
		#region Ȯ ư ǥ  - ShowExpandButton

        /// <summary>
        /// Ȯ ư ǥ 
        /// </summary>
		[Category(nameof(ExpanderPanel))]
		[Browsable(false)]
		[DefaultValue(false)]
		public override bool ShowExpandButton
		{
			get
			{
				return base.ShowExpandButton;
			}
			set
			{
				base.ShowExpandButton = value;
			}
		}

        #endregion
        #region ݱ   - IsClosable

        /// <summary>
        /// ݱ  
        /// </summary>
        [Category(nameof(ExpanderPanel))]
        [DefaultValue(true)]
        public bool IsClosable
        {
            get
            {
                return this.isClosable;
            }
            set
            {
                if(value.Equals(this.isClosable) == false)
                {
                    this.isClosable = value;

                    Invalidate(false);
                }
            }
        }

        #endregion
        #region ݱ ư ǥ  - ShowCloseButton

        /// <summary>
        /// ݱ ư ǥ 
        /// </summary>
        [Category(nameof(ExpanderPanel))]
        [Browsable(false)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        [DefaultValue(false)]
        public override bool ShowCloseButton
        {
            get
            {
                return base.ShowCloseButton;
            }
            set
            {
                base.ShowCloseButton = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - ExpanderPanel()

        /// <summary>
        /// 
        /// </summary>
		public ExpanderPanel()
		{
			InitializeComponent();

            BackColor    = Color.Transparent;
            CaptionStyle = CaptionStyle.Normal;
            ForeColor    = SystemColors.ControlText;
			Height       = this.CaptionHeight;
			ShowBorder   = true;

            this.customColor = new ExpanderPanelCustomColor();

            this.customColor.CustomColorChanged += customColor_CustomColorChanged;
		}

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region ׵θ ׸ - DrawBorder(graphics, expanderPanel)

        /// <summary>
        /// ׵θ ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="expanderPanel">ͽҴ г</param>
        private static void DrawBorder(Graphics graphics, ExpanderPanel expanderPanel)
        {
            if(expanderPanel.ShowBorder == true)
            {
                using(GraphicsPath graphicsPath = new GraphicsPath())
                {
                    using(Pen borderPen = new Pen(expanderPanel.PanelColor.BorderColor, ConstantHelper.BORDER_THICKNESS))
                    {
                        Rectangle captionRectangle = expanderPanel.CaptionRectangle;
                        Rectangle borderRectangle  = captionRectangle;

                        if(expanderPanel.Expanded == true)
                        {
                            borderRectangle = expanderPanel.ClientRectangle;

                            graphics.DrawLine
                            (
                                borderPen,
                                captionRectangle.Left,
                                captionRectangle.Top + captionRectangle.Height - ConstantHelper.BORDER_THICKNESS,
                                captionRectangle.Left + captionRectangle.Width,
                                captionRectangle.Top + captionRectangle.Height - ConstantHelper.BORDER_THICKNESS
                            );
                        }

                        ExpanderPanelList expanderPanelList = expanderPanel.Parent as ExpanderPanelList;

                        if((expanderPanelList != null) && (expanderPanelList.Dock == DockStyle.Fill))
                        {
                            Panel panel = expanderPanelList.Parent as Panel;

                            ExpanderPanel parentXPanderPanel = expanderPanelList.Parent as ExpanderPanel;

                            if(((panel != null) && (panel.Padding == new Padding(0))) || ((parentXPanderPanel != null) && (parentXPanderPanel.Padding == new Padding(0))))
                            {
                                if(expanderPanel.Top != 0)
                                {
                                    graphicsPath.AddLine
                                    (
                                        borderRectangle.Left,
                                        borderRectangle.Top,
                                        borderRectangle.Left + captionRectangle.Width,
                                        borderRectangle.Top
                                    );
                                }

                                graphics.DrawLine
                                (
                                    borderPen,
                                    borderRectangle.Left,
                                    borderRectangle.Top,
                                    borderRectangle.Left,
                                    borderRectangle.Top + borderRectangle.Height
                                );

                                graphics.DrawLine
                                (
                                    borderPen,
                                    borderRectangle.Left + borderRectangle.Width - ConstantHelper.BORDER_THICKNESS,
                                    borderRectangle.Top,
                                    borderRectangle.Left + borderRectangle.Width - ConstantHelper.BORDER_THICKNESS,
                                    borderRectangle.Top + borderRectangle.Height
                                );
                            }
                            else
                            {
                                if(expanderPanel.Top == 0)
                                {
                                    graphicsPath.AddLine
                                    (
                                        borderRectangle.Left,
                                        borderRectangle.Top,
                                        borderRectangle.Left + borderRectangle.Width,
                                        borderRectangle.Top
                                    );
                                }

                                graphicsPath.AddLine
                                (
                                    borderRectangle.Left,
                                    borderRectangle.Top,
                                    borderRectangle.Left,
                                    borderRectangle.Top + borderRectangle.Height
                                );

                                graphicsPath.AddLine
                                (
                                    borderRectangle.Left,
                                    borderRectangle.Top + borderRectangle.Height - ConstantHelper.BORDER_THICKNESS,
                                    borderRectangle.Left + borderRectangle.Width - ConstantHelper.BORDER_THICKNESS,
                                    borderRectangle.Top + borderRectangle.Height - ConstantHelper.BORDER_THICKNESS
                                );

                                graphicsPath.AddLine
                                (
                                    borderRectangle.Left + borderRectangle.Width - ConstantHelper.BORDER_THICKNESS,
                                    borderRectangle.Top,
                                    borderRectangle.Left + borderRectangle.Width - ConstantHelper.BORDER_THICKNESS,
                                    borderRectangle.Top + borderRectangle.Height
                                );
                            }
                        }
                        else
                        {
                            if(expanderPanel.Top == 0)
                            {
                                graphicsPath.AddLine
                                (
                                    borderRectangle.Left,
                                    borderRectangle.Top,
                                    borderRectangle.Left + borderRectangle.Width,
                                    borderRectangle.Top
                                );
                            }

                            graphicsPath.AddLine
                            (
                                borderRectangle.Left,
                                borderRectangle.Top,
                                borderRectangle.Left,
                                borderRectangle.Top + borderRectangle.Height
                            );

                            graphicsPath.AddLine
                            (
                                borderRectangle.Left,
                                borderRectangle.Top + borderRectangle.Height - ConstantHelper.BORDER_THICKNESS,
                                borderRectangle.Left + borderRectangle.Width - ConstantHelper.BORDER_THICKNESS,
                                borderRectangle.Top + borderRectangle.Height - ConstantHelper.BORDER_THICKNESS
                            );

                            graphicsPath.AddLine
                            (
                                borderRectangle.Left + borderRectangle.Width - ConstantHelper.BORDER_THICKNESS,
                                borderRectangle.Top,
                                borderRectangle.Left + borderRectangle.Width - ConstantHelper.BORDER_THICKNESS,
                                borderRectangle.Top + borderRectangle.Height
                            );
                        }
                    }

                    using(Pen borderPen = new Pen(expanderPanel.PanelColor.BorderColor, ConstantHelper.BORDER_THICKNESS))
                    {
                        graphics.DrawPath(borderPen, graphicsPath);
                    }
                }
            }
        }

        #endregion
        #region  ׵θ ׸ - DrawInnerBorder(graphics, expanderPanel)

        /// <summary>
        ///  ׵θ ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="expanderPanel">ͽҴ г</param>
        private static void DrawInnerBorder(Graphics graphics, ExpanderPanel expanderPanel)
        {
            if(expanderPanel.ShowBorder == true)
            {
                using(GraphicsPath graphicsPath = new GraphicsPath())
                {
                    Rectangle captionRectangle = expanderPanel.CaptionRectangle;

                    ExpanderPanelList expanderPanelList = expanderPanel.Parent as ExpanderPanelList;

                    if((expanderPanelList != null) && (expanderPanelList.Dock == DockStyle.Fill))
                    {
                        Panel panel = expanderPanelList.Parent as Panel;

                        ExpanderPanel parentXPanderPanel = expanderPanelList.Parent as ExpanderPanel;

                        if(((panel != null) && (panel.Padding == new Padding(0))) || ((parentXPanderPanel != null) && (parentXPanderPanel.Padding == new Padding(0))))
                        {
                            graphicsPath.AddLine
                            (
                                captionRectangle.X,
                                captionRectangle.Y + captionRectangle.Height,
                                captionRectangle.X,
                                captionRectangle.Y + ConstantHelper.BORDER_THICKNESS
                            );

                            if(expanderPanel.Top == 0)
                            {
                                graphicsPath.AddLine
                                (
                                    captionRectangle.X,
                                    captionRectangle.Y,
                                    captionRectangle.X + captionRectangle.Width,
                                    captionRectangle.Y
                                );
                            }
                            else
                            {
                                graphicsPath.AddLine
                                (
                                    captionRectangle.X,
                                    captionRectangle.Y + ConstantHelper.BORDER_THICKNESS,
                                    captionRectangle.X + captionRectangle.Width,
                                    captionRectangle.Y + ConstantHelper.BORDER_THICKNESS
                                );
                            }
                        }
                    }
                    else
                    {
                        graphicsPath.AddLine
                        (
                            captionRectangle.X + ConstantHelper.BORDER_THICKNESS,
                            captionRectangle.Y + captionRectangle.Height,
                            captionRectangle.X + ConstantHelper.BORDER_THICKNESS,
                            captionRectangle.Y
                        );

                        if(expanderPanel.Top == 0)
                        {
                            graphicsPath.AddLine
                            (
                                captionRectangle.X + ConstantHelper.BORDER_THICKNESS,
                                captionRectangle.Y + ConstantHelper.BORDER_THICKNESS,
                                captionRectangle.X + captionRectangle.Width - ConstantHelper.BORDER_THICKNESS,
                                captionRectangle.Y + ConstantHelper.BORDER_THICKNESS
                            );
                        }
                        else
                        {
                            graphicsPath.AddLine
                            (
                                captionRectangle.X + ConstantHelper.BORDER_THICKNESS,
                                captionRectangle.Y,
                                captionRectangle.X + captionRectangle.Width - ConstantHelper.BORDER_THICKNESS,
                                captionRectangle.Y
                            );
                        }
                    }

                    using(Pen borderPen = new Pen(expanderPanel.PanelColor.InnerBorderColor))
                    {
                        graphics.DrawPath(borderPen, graphicsPath);
                    }
                }
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Protected

        #region 콺 UP óϱ - OnMouseUp(e)

        /// <summary>
        /// 콺 UP óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnMouseUp(MouseEventArgs e)
        {
            if(CaptionRectangle.Contains(e.X, e.Y) == true)
            {
                if((ShowCloseButton == false) && (ShowExpandButton == false))
                {
                    OnExpandButtonClick(this, EventArgs.Empty);
                }
                else if((ShowCloseButton == true) && (ShowExpandButton == false))
                {
                    if(CloseButtonRectangle.Contains(e.X, e.Y) == false)
                    {
                        OnExpandButtonClick(this, EventArgs.Empty);
                    }
                }

                if(ShowExpandButton == true)
                {
                    if(ExpandButtonRectangle.Contains(e.X, e.Y) == true)
                    {
                        OnExpandButtonClick(this, EventArgs.Empty);
                    }
                }

                if((ShowCloseButton == true) && (this.isClosable == true))
                {
                    if(CloseButtonRectangle.Contains(e.X, e.Y) == true)
                    {
                        OnCloseButtonClick(this, EventArgs.Empty);
                    }
                }
            }
        }

        #endregion
        #region  Ʈ óϱ - OnPaintBackground(e)

        /// <summary>
        ///  Ʈ óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
		protected override void OnPaintBackground(PaintEventArgs e)
		{
			base.OnPaintBackground(e);

            base.BackColor = Color.Transparent;

            Color backgroundColor = PanelColor.ExpanderPanelBackgroundColor;

            if((backgroundColor != Color.Empty) && backgroundColor != Color.Transparent)
            {
                Rectangle rectangle = new Rectangle
                (
                    0,
                    CaptionHeight,
                    ClientRectangle.Width,
                    ClientRectangle.Height - CaptionHeight
                );

                using(SolidBrush brush = new SolidBrush(backgroundColor))
                {
                    e.Graphics.FillRectangle(brush, rectangle);
                }
            }
		}

        #endregion
        #region Ʈ óϱ - OnPaint(e)

        /// <summary>
        /// Ʈ óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
		protected override void OnPaint(PaintEventArgs e)
		{
            if(IsZeroWidthOrHeight(CaptionRectangle) == true)
            {
                return;
            }

            using(AntiAliasHelper antiAlias = new AntiAliasHelper(e.Graphics))
            {
                Graphics graphics = e.Graphics;

                using(ClearTypeGridFitHelper helper = new ClearTypeGridFitHelper(graphics))
                {
                    bool      expanded        = Expanded;
                    bool      showBorder      = ShowBorder;
                    Color     borderColor     = PanelColor.BorderColor;
                    Rectangle borderRectangle = ClientRectangle;
                    
                    switch(PanelStyle)
                    {
                        case PanelStyle.Default    :
                        case PanelStyle.Office2007 :

                            DrawCaptionBar(graphics, expanded, showBorder, PanelStyle);

                            CalculatePanelHeight();

                            DrawBorder(graphics, this);

                            break;
                    }
                }
            }
		}

        #endregion
        #region ǥ   óϱ - OnVisibleChanged(e)

        /// <summary>
        /// ǥ   óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnVisibleChanged(EventArgs e)
        {
            base.OnVisibleChanged(e);

            if(DesignMode == true)
            {
                return;
            }

            if(Visible == false)
            {
                if(Expanded == true)
                {
                    Expanded = false;

                    foreach(Control control in Parent.Controls)
                    {
                        ExpanderPanel expanderPanel = control as ExpanderPanel;

                        if(expanderPanel != null)
                        {
                            if(expanderPanel.Visible == true)
                            {
                                expanderPanel.Expanded = true;

                                return;
                            }
                        }
                    }
                }
            }

            CalculatePanelHeight();
        }

        #endregion

        #region  Ÿ  óϱ - OnCaptionStyleChanged(sender, e)

        /// <summary>
        ///  Ÿ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void OnCaptionStyleChanged(object sender, EventArgs e)
        {
            Invalidate(CaptionRectangle);

            CaptionStyleChanged?.Invoke(sender, e);
        }

        #endregion
        #region г Ȯ óϱ - OnPanelExpanded(sender, e)

        /// <summary>
        /// г Ȯ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected override void OnPanelExpanded(object sender, PanelStateChangedEventArgs e)
		{
			bool expanded = e.Expanded;

			if(expanded == true)
			{
				Expanded = expanded;

                Invalidate(false);
			}

			base.OnPanelExpanded(sender, e);
		}

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region   ׸ - DrawCaptionBar(graphics, expanded, showBorder, panelStyle)

        /// <summary>
        ///   ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="expanded">Ȯ </param>
        /// <param name="showBorder">׵θ ǥ </param>
        /// <param name="panelStyle">г Ÿ</param>
        private void DrawCaptionBar(Graphics graphics, bool expanded, bool showBorder, PanelStyle panelStyle)
        {
            Rectangle captionRectangle  = CaptionRectangle;
            Color     beginColor        = PanelColor.ExpanderPanelCaptionBarBeginColor;
            Color     middleColor       = PanelColor.ExpanderPanelCaptionBarMiddleColor;
            Color     endColor          = PanelColor.ExpanderPanelCaptionBarEndColor;
            Color     textColor         = PanelColor.ExpanderPanelCaptionTextColor;
            Color     closeButtonColor  = PanelColor.ExpanderPanelCloseButtonColor;
            Color     expandButtonColor = PanelColor.ExpanderPanelExpandButtonColor;
            bool      isHover           = CaptionBarHoverState == HoverState.Hover ? true : false;

            if(this.closeButtonImage == null)
            {
                this.closeButtonImage = Resources.ClosePanel;
            }

            if(this.chevronUpImage == null)
            {
                this.chevronUpImage = Resources.ChevronUp;
            }

            if(this.chevronDownImage == null)
            {
                this.chevronDownImage = Resources.ChevronDown;
            }
            
            this.chevronImage = this.chevronDownImage;

            if(expanded == true)
            {
                this.chevronImage = this.chevronUpImage;
            }

            if(this.captionStyle == CaptionStyle.Normal)
            {
                if(isHover == true)
                {
                    beginColor  = PanelColor.ExpanderPanelCaptionBarSelectedBeginColor;
                    middleColor = PanelColor.ExpanderPanelCaptionBarSelectedMiddleColor;
                    endColor    = PanelColor.ExpanderPanelCaptionBarSelectedEndColor;

                    if(expanded == true)
                    {
                        beginColor  = PanelColor.ExpanderPanelCaptionBarPressedBeginColor;
                        middleColor = PanelColor.ExpanderPanelCaptionBarPressedMiddleColor;
                        endColor    = PanelColor.ExpanderPanelCaptionBarPressedEndColor;
                    }

                    textColor = PanelColor.ExpanderPanelCaptionBarTextSelectedColor;

                    expandButtonColor = textColor;
                    closeButtonColor  = textColor;
                }
                else
                {
                    if(expanded == true)
                    {
                        beginColor  = PanelColor.ExpanderPanelCaptionBarCheckedBeginColor;
                        middleColor = PanelColor.ExpanderPanelCaptionBarCheckedMiddleColor;
                        endColor    = PanelColor.ExpanderPanelCaptionBarCheckedEndColor;

                        textColor = PanelColor.ExpanderPanelCaptionBarTextSelectedColor;

                        closeButtonColor  = textColor;
                        expandButtonColor = textColor;
                    }
                }

                if(panelStyle != PanelStyle.Office2007)
                {
                    RenderCaptionBarBackground
                    (
                        graphics,
                        captionRectangle,
                        beginColor,
                        middleColor,
                        endColor,
                        LinearGradientMode.Vertical,
                        false
                    );
                }
                else
                {
                    RenderButtonBackground
                    (
                        graphics,
                        captionRectangle,
                        beginColor,
                        middleColor,
                        endColor
                    );
                }
            }
            else
            {
                Color flatBeginColor   = PanelColor.ExpanderPanelCaptionBarFlatBeginColor;
                Color flatEndColor     = PanelColor.ExpanderPanelCaptionBarFlatEndColor;
                Color innerBorderColor = PanelColor.InnerBorderColor;

                textColor = PanelColor.ExpanderPanelCaptionTextColor;

                expandButtonColor = textColor;

                RenderFlatButtonBackground(graphics, captionRectangle, flatBeginColor, flatEndColor, isHover);

                DrawInnerBorder(graphics, this);
            }

            DrawImageAndText
            (
                graphics,
                captionRectangle,
                CAPTION_SPACING,
                this.ImageRectangle,
                this.Image,
                this.RightToLeft,
                this.isClosable,
                this.ShowCloseButton,
                this.closeButtonImage,
                closeButtonColor,
                ref this.CloseButtonRectangle,
                this.ShowExpandButton,
                this.chevronImage,
                expandButtonColor,
                ref this.ExpandButtonRectangle,
                this.CaptionFont,
                textColor,
                this.Text
            );
        }

        #endregion
        #region г  ϱ - CalculatePanelHeight()

        /// <summary>
        /// г  ϱ
        /// </summary>
		private void CalculatePanelHeight()
		{
			if(Parent == null)
			{
				return;
			}

            int panelHeight = Parent.Padding.Top;

            foreach(Control control in Parent.Controls)
            {
				ExpanderPanel expanderPanel = control as ExpanderPanel;

                if((expanderPanel != null) && (expanderPanel.Visible == true))
                {
                    panelHeight += expanderPanel.CaptionHeight;
                }
            }

			panelHeight += Parent.Padding.Bottom;

            foreach(Control control in Parent.Controls)
			{
				ExpanderPanel expanderPanel = control as ExpanderPanel;

                if(expanderPanel != null)
                {
                    if(expanderPanel.Expanded == true)
                    {
                        expanderPanel.Height = this.Parent.Height + expanderPanel.CaptionHeight - panelHeight;
                    }
                    else
                    {
                        expanderPanel.Height = expanderPanel.CaptionHeight;
                    }
                }
			}

			int top = this.Parent.Padding.Top;

			foreach(Control control in Parent.Controls)
			{
				ExpanderPanel expanderPanel = control as ExpanderPanel;

                if((expanderPanel != null) && (expanderPanel.Visible == true))
                {
                    expanderPanel.Top = top;

                    top += expanderPanel.Height;
                }
			}
		}

        #endregion
    }
}