﻿using System.Drawing;
using System.Windows.Forms;
using System.Windows.Forms.Design.Behavior;

namespace TestProject
{
    /// <summary>
    /// 익스팬더 패널 제목 클릭 비헤이비어
    /// </summary>
    internal class ExpanderPanelCaptionClickBehavior : Behavior
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 익스팬더 패널
        /// </summary>
        private ExpanderPanel expanderPanel;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ExpanderPanelCaptionClickBehavior(expanderPanel)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="expanderPanel">익스팬더 패널</param>
        public ExpanderPanelCaptionClickBehavior(ExpanderPanel expanderPanel)
        {
            this.expanderPanel = expanderPanel;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 마우스 DOWN 처리하기 - OnMouseDown(glyph, mouseButtons, mousePoint)

        /// <summary>
        /// 마우스 DOWN 처리하기
        /// </summary>
        /// <param name="glyph">글리프</param>
        /// <param name="mouseButtons">마우스 버튼</param>
        /// <param name="mousePoint">마우스 포인트</param>
        /// <returns>처리 결과</returns>
        public override bool OnMouseDown(Glyph glyph, MouseButtons mouseButtons, Point mousePoint)
        {
            if((this.expanderPanel != null) && (this.expanderPanel.Expanded == false))
            {
                ExpanderPanelList expanderPanelList = this.expanderPanel.Parent as ExpanderPanelList;

                if(expanderPanelList != null)
                {
                    expanderPanelList.Expand(this.expanderPanel);

                    this.expanderPanel.Invalidate(false);
                }
            }

            return true;
        }

        #endregion
    }
}