﻿using System;
using System.ComponentModel.Design;

namespace TestProject
{
    /// <summary>
    /// 익스팬더 패널 컬렉션 에디터
    /// </summary>
    internal class ExpanderPanelCollectionEditor : CollectionEditor
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 컬렉션 폼
        /// </summary>
        private CollectionForm collectionForm;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ExpanderPanelCollectionEditor(type)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="type">타입</param>
        public ExpanderPanelCollectionEditor(Type type) : base(type)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 컬렉션 폼 생성하기 - CreateCollectionForm()

        /// <summary>
        /// 컬렉션 폼 생성하기
        /// </summary>
        /// <returns>컬렉션 폼</returns>
        protected override CollectionForm CreateCollectionForm()
        {
            this.collectionForm = base.CreateCollectionForm();

            return this.collectionForm;
        }

        #endregion
        #region 인스턴스 생성하기 - CreateInstance(ItemType)

        /// <summary>
        /// 인스턴스 생성하기
        /// </summary>
        /// <param name="ItemType">항목 타입</param>
        /// <returns>객체</returns>
        protected override object CreateInstance(Type ItemType)
        {
            ExpanderPanel expanderPanel = (ExpanderPanel)base.CreateInstance(ItemType);

            if(Context.Instance != null)
            {
                expanderPanel.Expanded = true;
            }

            return expanderPanel;
        }

        #endregion
    }
}