using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Design;
using System.Drawing.Drawing2D;
using System.Globalization;
using System.Windows.Forms;

using TestProject.Properties;

namespace TestProject
{
    /// <summary>
    /// ͽҴ г Ʈ
    /// </summary>
    [DesignTimeVisibleAttribute(true)]
    [Designer(typeof(ExpanderPanelListDesigner))]
    [ToolboxBitmap(typeof(System.Windows.Forms.Panel))]
    public partial class ExpanderPanelList : ScrollableControl
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Event
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region г Ÿ  ̺Ʈ - PanelStyleChanged

        /// <summary>
        /// г Ÿ  ̺Ʈ
        /// </summary>
        public event EventHandler<PanelStyleChangedEventArgs> PanelStyleChanged;

        #endregion
        #region  Ŵ  ̺Ʈ - ColorSchemeChanged

        /// <summary>
        ///  Ŵ  ̺Ʈ
        /// </summary>
        public event EventHandler<ColorSchemeChangedEventArgs> ColorSchemeChanged;

        #endregion
        #region  Ÿ  ̺Ʈ - CaptionStyleChanged

        /// <summary>
        ///  Ÿ  ̺Ʈ
        /// </summary>
        public event EventHandler<EventArgs> CaptionStyleChanged;

        #endregion
        #region    ̺Ʈ - CaptionHeightChanged

        /// <summary>
        ///    ̺Ʈ
        /// </summary>
        public event EventHandler<EventArgs> CaptionHeightChanged;
        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// г Ÿ
        /// </summary>
        private PanelStyle panelStyle;

        /// <summary>
        ///  Ŵ
        /// </summary>
        private ColorScheme colorScheme;

        /// <summary>
        /// г 
        /// </summary>
        private PanelColor panelColor;

        /// <summary>
        /// ׵θ ǥ 
        /// </summary>
        private bool showBorder;

        /// <summary>
        /// ׶Ʈ  ǥ 
        /// </summary>
        private bool showGradientBackground;

        /// <summary>
        ///  ׶Ʈ 
        /// </summary>
        private LinearGradientMode linearGradientMode;

        /// <summary>
        /// ׶Ʈ 
        /// </summary>
        private Color gradientBackgroundColor;

        /// <summary>
        ///  Ÿ
        /// </summary>
        private CaptionStyle captionStyle;

        /// <summary>
        ///  
        /// </summary>
        private int captionHeight;

        /// <summary>
        /// Ȯ ư ǥ 
        /// </summary>
        private bool showExpandButton;

        /// <summary>
        /// ݱ ư ǥ 
        /// </summary>
        private bool showCloseButton;

        /// <summary>
        /// ͽҴ г ÷
        /// </summary>
        private ExpanderPanelCollection expanderPanelCollection;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region г Ÿ - PanelStyle

        /// <summary>
        /// г Ÿ
        /// </summary>
        [Category(nameof(ExpanderPanelList))]
        [DefaultValue(PanelStyle.Default)]
        public PanelStyle PanelStyle
        {
            get
            {
                return this.panelStyle;
            }
            set
            {
                if(value != this.panelStyle)
                {
                    this.panelStyle = value;

                    OnPanelStyleChanged(this, new PanelStyleChangedEventArgs(this.panelStyle));
                }
            }
        }

        #endregion
        #region  Ŵ - ColorScheme

        /// <summary>
        ///  Ŵ
        /// </summary>
        [Category(nameof(ExpanderPanelList))]
        [DefaultValue(ColorScheme.Professional)]
        public ColorScheme ColorScheme
        {
            get
            {
                return this.colorScheme;
            }
            set
            {
                if(value != this.colorScheme)
                {
                    this.colorScheme = value;

                    OnColorSchemeChanged(this, new ColorSchemeChangedEventArgs(this.colorScheme));
                }
            }
        }

        #endregion
        #region г  - PanelColor

        /// <summary>
        /// г 
        /// </summary>
        public PanelColor PanelColor
        {
            get
            {
                return this.panelColor;
            }
            set
            {
                this.panelColor = value;
            }
        }

        #endregion
        #region ׵θ ǥ  - ShowBorder

        /// <summary>
        /// ׵θ ǥ 
        /// </summary>
        [DefaultValue(true)]
        [Category(nameof(ExpanderPanelList))]
        public bool ShowBorder
        {
            get
            {
                return this.showBorder;
            }
            set
            {
                if(value != this.showBorder)
                {
                    this.showBorder = value;

                    foreach(ExpanderPanel expanderPanel in ExpanderPanelCollection)
                    {
                        expanderPanel.ShowBorder = this.showBorder;
                    }

                    Invalidate(false);
                }
            }
        }

        #endregion
        #region ׶Ʈ  ǥ  - ShowGradientBackground

        /// <summary>
        /// ׶Ʈ  ǥ 
        /// </summary>
        [Category("Appearance")]
        [DefaultValue(false)]
        public bool ShowGradientBackground
        {
            get
            {
                return this.showGradientBackground;
            }
            set
            {
                if(value != this.showGradientBackground)
                {
                    this.showGradientBackground = value;

                    Invalidate(false);
                }
            }
        }

        #endregion
        #region  ׶Ʈ  - LinearGradientMode

        /// <summary>
        ///  ׶Ʈ 
        /// </summary>
        [Category(nameof(ExpanderPanelList))]
        [DefaultValue(LinearGradientMode.Vertical)]
        public LinearGradientMode LinearGradientMode
        {
            get
            {
                return this.linearGradientMode;
            }
            set
            {
                if(value != this.linearGradientMode)
                {
                    this.linearGradientMode = value;

                    Invalidate(false);
                }
            }
        }

        #endregion
        #region ׶Ʈ   - GradientBackgroundColor

        /// <summary>
        /// ׶Ʈ  
        /// </summary>
        [Category(nameof(ExpanderPanelList))]
        [DefaultValue(false)]
        public Color GradientBackgroundColor
        {
            get
            {
                return this.gradientBackgroundColor;
            }
            set
            {
                if(value != this.gradientBackgroundColor)
                {
                    this.gradientBackgroundColor = value;

                    Invalidate(false);
                }
            }
        }

        #endregion
        #region  Ÿ - CaptionStyle

        /// <summary>
        ///  Ÿ
        /// </summary>
        [Category(nameof(ExpanderPanelList))]
        public CaptionStyle CaptionStyle
        {
            get
            {
                return this.captionStyle;
            }
            set
            {
                this.captionStyle = value;

                OnCaptionStyleChanged(this, EventArgs.Empty);
            }
        }

        #endregion
        #region   - CaptionHeight

        /// <summary>
        ///  
        /// </summary>
        [Category(nameof(ExpanderPanelList))]
        [DefaultValue(25)]
        public int CaptionHeight
        {
            get
            {
                return captionHeight;
            }
            set
            {
                if(value < ConstantHelper.CAPTION_MINIMUM_HEIGHT)
                {
                    throw new InvalidOperationException
                    (
                        string.Format
                        (
                            CultureInfo.CurrentUICulture,
                            ConstantHelper.INVALID_OPERATION_EXCEPTION,
                            value,
                            "CaptionHeight",
                            ConstantHelper.CAPTION_MINIMUM_HEIGHT
                        )
                    );
                }

                this.captionHeight = value;

                OnCaptionHeightChanged(this, EventArgs.Empty);
            }
        }

        #endregion
        #region Ȯ ư ǥ  - ShowExpandButton

        /// <summary>
        /// Ȯ ư ǥ 
        /// </summary>
        [Category(nameof(ExpanderPanelList))]
        [DefaultValue(false)]
        public bool ShowExpandButton
        {
            get
            {
                return this.showExpandButton;
            }
            set
            {
                if(value != this.showExpandButton)
                {
                    this.showExpandButton = value;

                    foreach(ExpanderPanel expanderPanel in this.ExpanderPanelCollection)
                    {
                        expanderPanel.ShowExpandButton = this.showExpandButton;
                    }
                }
            }
        }

        #endregion
        #region ݱ ư ǥ  - ShowCloseButton

        /// <summary>
        /// ݱ ư ǥ 
        /// </summary>
        [Category(nameof(ExpanderPanelList))]
        [DefaultValue(false)]
        public bool ShowCloseButton
        {
            get
            {
                return this.showCloseButton;
            }
            set
            {
                if(value != this.showCloseButton)
                {
                    this.showCloseButton = value;

                    foreach(ExpanderPanel expanderPanel in this.ExpanderPanelCollection)
                    {
                        expanderPanel.ShowCloseButton = this.showCloseButton;
                    }
                }
            }
        }

        #endregion
        #region ͽҴ г ÷ - ExpanderPanelCollection

        /// <summary>
        /// ͽҴ г ÷
        /// </summary>
        [Category(nameof(ExpanderPanelList))]
        [Browsable(true)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        [RefreshProperties(RefreshProperties.Repaint)]
        [Editor(typeof(ExpanderPanelCollectionEditor), typeof(UITypeEditor))]
        public ExpanderPanelCollection ExpanderPanelCollection
        {
            get
            {
                return this.expanderPanelCollection;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - ExpanderPanelList()

        /// <summary>
        /// 
        /// </summary>
        public ExpanderPanelList()
        {
            SetStyle(ControlStyles.DoubleBuffer                , true );
            SetStyle(ControlStyles.ResizeRedraw                , false);
            SetStyle(ControlStyles.UserPaint                   , true );
            SetStyle(ControlStyles.AllPaintingInWmPaint        , true );
            SetStyle(ControlStyles.SupportsTransparentBackColor, true );
            
            InitializeComponent();

            this.expanderPanelCollection = new ExpanderPanelCollection(this);
            
            ShowBorder         = true;
            PanelStyle         = PanelStyle.Default;
            LinearGradientMode = LinearGradientMode.Vertical;
            CaptionHeight      = 25;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ȯϱ - Expand(basePanel)

        /// <summary>
        /// Ȯϱ
        /// </summary>
        /// <param name="basePanel">̽ г</param>
        public void Expand(BasePanel basePanel)
        {
            if(basePanel == null)
            {
                throw new ArgumentNullException
                (
                    "basePanel",
                    string.Format
                    (
                        CultureInfo.InvariantCulture,
                        ConstantHelper.ARGUMENT_EXCAPTION_MESSAGE,
                        "basePanel"
                    )
                );
            }

            ExpanderPanel expanderPanel = basePanel as ExpanderPanel;

            if(expanderPanel != null)
            {
                foreach(ExpanderPanel sourcePanel in this.expanderPanelCollection)
                {
                    if(sourcePanel.Equals(expanderPanel) == false)
                    {
                        sourcePanel.Expanded = false;
                    }
                }

                PropertyDescriptor propertyDescriptor = TypeDescriptor.GetProperties(expanderPanel)["Expanded"];

                if(propertyDescriptor != null)
                {
                    propertyDescriptor.SetValue(expanderPanel, true);
                }
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region ũ  óϱ - OnResize(e)

        /// <summary>
        /// ũ  óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnResize(EventArgs e)
        {
            base.OnResize(e);

            int expanderPanelCaptionHeight = 0;
            
            if(this.expanderPanelCollection != null)
            {
                foreach(ExpanderPanel expanderPanel in this.expanderPanelCollection)
                {
                    expanderPanel.Width = ClientRectangle.Width - Padding.Left - Padding.Right;

                    if(expanderPanel.Visible == false)
                    {
                        expanderPanelCaptionHeight -= expanderPanel.CaptionHeight;
                    }

                    expanderPanelCaptionHeight += expanderPanel.CaptionHeight;
                }

                foreach(ExpanderPanel expanderPanel in this.expanderPanelCollection)
                {
                    if(expanderPanel.Expanded == true)
                    {
                        expanderPanel.Height = this.Height - expanderPanelCaptionHeight - Padding.Top - Padding.Bottom + expanderPanel.CaptionHeight;

                        return;
                    }
                }
            }
        }

        #endregion
        #region  Ʈ óϱ - OnPaintBackground(e)

        /// <summary>
        ///  Ʈ óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnPaintBackground(PaintEventArgs e)
        {
            base.OnPaintBackground(e);

            if(this.showGradientBackground == true)
            {
                Rectangle rectangle = new Rectangle(0, 0, ClientRectangle.Width, ClientRectangle.Height);

                using(LinearGradientBrush brush = new LinearGradientBrush(rectangle, BackColor, GradientBackgroundColor, LinearGradientMode))
                {
                    e.Graphics.FillRectangle(brush, rectangle);
                }
            }
        }

        #endregion
        #region Ʈ ߰ óϱ - OnControlAdded(e)

        /// <summary>
        /// Ʈ ߰ óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnControlAdded(ControlEventArgs e)
        {
            base.OnControlAdded(e);

            ExpanderPanel expanderPanel = e.Control as ExpanderPanel;

            if(expanderPanel != null)
            {
                if(expanderPanel.Expanded == true)
                {
                    foreach(ExpanderPanel sourcePanel in this.expanderPanelCollection)
                    {
                        if(sourcePanel != expanderPanel)
                        {
                            sourcePanel.Expanded = false;

                            sourcePanel.Height = expanderPanel.CaptionHeight;
                        }
                    }
                }

                expanderPanel.Parent = this;

                expanderPanel.Anchor      = ((AnchorStyles)(((AnchorStyles.Top | AnchorStyles.Left) | AnchorStyles.Right)));
                expanderPanel.Left        = Padding.Left;
                expanderPanel.Width       = ClientRectangle.Width - Padding.Left - Padding.Right;
                expanderPanel.PanelStyle  = PanelStyle;
                expanderPanel.ColorScheme = ColorScheme;

                if(PanelColor != null)
                {
                    expanderPanel.SetPanelColor(this.PanelColor);
                }

                expanderPanel.ShowBorder       = this.showBorder;
                expanderPanel.ShowCloseButton  = this.showCloseButton;
                expanderPanel.ShowExpandButton = this.showExpandButton;
                expanderPanel.CaptionStyle     = this.captionStyle;
                expanderPanel.Top              = GetTopPosition();

                expanderPanel.PanelStyleChanged += expanderPanel_PanelStyleChanged;
                expanderPanel.ExpandButtonClick += expanderPanel_ExpandButtonClick;
                expanderPanel.CloseButtonClick  += expanderPanel_CloseButtonClick;
            }
            else
            {
                throw new InvalidOperationException("Can only add ExpanderPanel");
            }
        }

        #endregion
        #region Ʈ Ž óϱ - OnControlRemoved(e)

        /// <summary>
        /// Ʈ Ž óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnControlRemoved(ControlEventArgs e)
        {
            base.OnControlRemoved(e);

            ExpanderPanel expanderPanel = e.Control as ExpanderPanel;

            if(expanderPanel != null)
            {
                expanderPanel.PanelStyleChanged -= expanderPanel_PanelStyleChanged;
                expanderPanel.ExpandButtonClick -= expanderPanel_ExpandButtonClick;
                expanderPanel.CloseButtonClick  -= expanderPanel_CloseButtonClick;
            }
        }

        #endregion

        #region г Ÿ  óϱ - OnPanelStyleChanged(sender, e)

        /// <summary>
        /// г Ÿ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void OnPanelStyleChanged(object sender, PanelStyleChangedEventArgs e)
        {
            PanelStyle panelStyle = e.PanelStyle;

            Padding = new Padding(0);

            foreach(ExpanderPanel epanderPanel in this.expanderPanelCollection)
            {
                PropertyDescriptorCollection propertyDescriptorCollection = TypeDescriptor.GetProperties(epanderPanel);

                if(propertyDescriptorCollection.Count > 0)
                {
                    PropertyDescriptor panelStylePropertyDescriptor = propertyDescriptorCollection["PanelStyle"];

                    if(panelStylePropertyDescriptor != null)
                    {
                        panelStylePropertyDescriptor.SetValue(epanderPanel, panelStyle);
                    }

                    PropertyDescriptor leftPropertyDescriptor = propertyDescriptorCollection["Left"];

                    if(leftPropertyDescriptor != null)
                    {
                        leftPropertyDescriptor.SetValue(epanderPanel, this.Padding.Left);
                    }

                    PropertyDescriptor widthPropertyDescriptor = propertyDescriptorCollection["Width"];

                    if(widthPropertyDescriptor != null)
                    {
                        widthPropertyDescriptor.SetValue(epanderPanel, ClientRectangle.Width - Padding.Left - Padding.Right);
                    }
                }
            }

            PanelStyleChanged?.Invoke(sender, e);
        }

        #endregion
        #region  Ŵ  óϱ - OnColorSchemeChanged(sender, e)

        /// <summary>
        ///  Ŵ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void OnColorSchemeChanged(object sender, ColorSchemeChangedEventArgs e)
        {
            ColorScheme colorScheme = e.ColorSchema;

            foreach(ExpanderPanel epanderPanel in this.expanderPanelCollection)
            {
                PropertyDescriptor propertyDescriptor = TypeDescriptor.GetProperties(epanderPanel)["ColorScheme"];

                if(propertyDescriptor != null)
                {
                    propertyDescriptor.SetValue(epanderPanel, colorScheme);
                }
            }

            ColorSchemeChanged?.Invoke(sender, e);
        }

        #endregion
        #region    óϱ - OnCaptionHeightChanged(sender, e)

        /// <summary>
        ///    óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void OnCaptionHeightChanged(object sender, EventArgs e)
        {
            foreach(ExpanderPanel epanderPanel in this.expanderPanelCollection)
            {
                PropertyDescriptor propertyDescriptor = TypeDescriptor.GetProperties(epanderPanel)["CaptionHeight"];

                if(propertyDescriptor != null)
                {
                    propertyDescriptor.SetValue(epanderPanel, this.captionHeight);
                }
            }

            CaptionHeightChanged?.Invoke(sender, e);
        }

        #endregion
        #region  Ÿ  óϱ - OnCaptionStyleChanged(sender, e)

        /// <summary>
        ///  Ÿ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected virtual void OnCaptionStyleChanged(object sender, EventArgs e)
        {
            foreach(ExpanderPanel epanderPanel in this.expanderPanelCollection)
            {
                PropertyDescriptor propertyDescriptor = TypeDescriptor.GetProperties(epanderPanel)["CaptionStyle"];

                if(propertyDescriptor != null)
                {
                    propertyDescriptor.SetValue(epanderPanel, this.captionStyle);
                }
            }

            CaptionStyleChanged?.Invoke(sender, e);
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region ͽҴ г г Ÿ  óϱ - expanderPanel_PanelStyleChanged(sender, e)

        /// <summary>
        /// ͽҴ г г Ÿ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void expanderPanel_PanelStyleChanged(object sender, PanelStyleChangedEventArgs e)
        {
            PanelStyle panelStyle = e.PanelStyle;

            if(panelStyle != this.panelStyle)
            {
                PanelStyle = panelStyle;
            }
        }

        #endregion
        #region ͽҴ г Ȯ ư Ŭ óϱ - expanderPanel_ExpandButtonClick(sender, e)

        /// <summary>
        /// ͽҴ г Ȯ ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void expanderPanel_ExpandButtonClick(object sender, EventArgs e)
        {
            ExpanderPanel expanderPanel = sender as ExpanderPanel;

            if(expanderPanel != null)
            {
                Expand(expanderPanel);
            }
        }

        #endregion
        #region ͽҴ г ݱ ư Ŭ óϱ - expanderPanel_CloseButtonClick(sender, e)

        /// <summary>
        /// ͽҴ г ݱ ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void expanderPanel_CloseButtonClick(object sender, EventArgs e)
        {
            ExpanderPanel epanderPanel = sender as ExpanderPanel;

            if(epanderPanel != null)
            {
                Controls.Remove(epanderPanel);
            }
        }

        #endregion

        #region  ġ ϱ - GetTopPosition()

        /// <summary>
        ///  ġ ϱ
        /// </summary>
        /// <returns> ġ</returns>
        private int GetTopPosition()
        {
            int topPosition     = Padding.Top;
            int nextTopPosition = 0;

            IEnumerator enumerator = this.expanderPanelCollection.GetEnumerator();

            while(enumerator.MoveNext())
            {
                ExpanderPanel epanderPanel = (ExpanderPanel)enumerator.Current;

                if(epanderPanel.Visible == true)
                {
                    if(nextTopPosition == Padding.Top)
                    {
                        topPosition = Padding.Top;
                    }
                    else
                    {
                        topPosition = nextTopPosition;
                    }

                    nextTopPosition = topPosition + epanderPanel.Height;
                }
            }

            return topPosition;
        }

        #endregion
    }
}