using System;
using System.Collections;
using System.Globalization;
using System.Threading;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// г 
    /// </summary>
    public static class PanelHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region ̽ г Ʈ ã - FindBasePanelList(searchAllChildren, sourceCollection)

        /// <summary>
        /// ̽ г Ʈ ã
        /// </summary>
        /// <param name="searchAllChildren"> ڽ ã </param>
        /// <param name="sourceCollection">ҽ ÷</param>
        /// <returns>ã ̽ г Ʈ</returns>
        public static ArrayList FindBasePanelList(bool searchAllChildren, Control.ControlCollection sourceCollection)
        {
            return FindControlList(typeof(BasePanel), searchAllChildren, sourceCollection, new ArrayList());
        }

        #endregion
        #region ͽҴ г Ʈ Ʈ ã - FindExpanderPanelListList(searchAllChildren, sourceCollection)

        /// <summary>
        /// ͽҴ г Ʈ Ʈ ã
        /// </summary>
        /// <param name="searchAllChildren"> ڽ ã </param>
        /// <param name="sourceCollection">ҽ ÷</param>
        /// <returns>ͽҴ г Ʈ Ʈ</returns>
        public static ArrayList FindExpanderPanelListList(bool searchAllChildren, Control.ControlCollection sourceCollection)
        {
            return FindControlList(typeof(ExpanderPanelList), searchAllChildren, sourceCollection, new ArrayList());
        }

        #endregion

        #region г Ӽ ϱ - SetPanelProperties(sourceCollection, panelStyle, panelColor)

        /// <summary>
        /// г Ӽ ϱ
        /// </summary>
        /// <param name="sourceCollection">ҽ ÷</param>
        /// <param name="panelStyle">г Ÿ</param>
        /// <param name="panelColor">г </param>
        public static void SetPanelProperties(Control.ControlCollection sourceCollection, PanelStyle panelStyle, PanelColor panelColor)
        {
            if(panelColor == null)
            {
                throw new ArgumentNullException
                (
                    "panelColor",
                    string.Format
                    (
                        CultureInfo.InvariantCulture,
                        ConstantHelper.ARGUMENT_EXCAPTION_MESSAGE,
                        "panelColor"
                    )
                );
            }

			ArrayList basePanelList = FindBasePanelList(true, sourceCollection);

            foreach(BasePanel basePanel in basePanelList)
            {
                basePanel.PanelStyle = panelStyle;

                panelColor.Panel = basePanel;

                basePanel.SetPanelColor(panelColor);
            }

            ArrayList expanderPanelListList = FindExpanderPanelListList(true, sourceCollection);

            foreach(ExpanderPanelList expanderPanelList in expanderPanelListList)
            {
                expanderPanelList.PanelStyle = panelStyle;
                expanderPanelList.PanelColor = panelColor;
            }
        }

        #endregion
        #region г Ӽ ϱ - SetPanelProperties(sourceCollection, panelColor)

        /// <summary>
        /// г Ӽ ϱ
        /// </summary>
        /// <param name="sourceCollection">ҽ ÷</param>
        /// <param name="panelColor">г </param>
        public static void SetPanelProperties(Control.ControlCollection sourceCollection, PanelColor panelColor)
        {
            if(panelColor == null)
            {
                throw new ArgumentNullException
                (
                    "panelColor",
                    string.Format
                    (
                        CultureInfo.InvariantCulture,
                        ConstantHelper.ARGUMENT_EXCAPTION_MESSAGE,
                        "panelColor"
                    )
                );
            }

            PanelStyle panelStyle = panelColor.PanelStyle;

            SetPanelProperties(sourceCollection, panelStyle, panelColor);
        }

        #endregion
        #region г Ӽ ϱ - SetPanelProperties(sourceCollection, panelStyle)

        /// <summary>
        /// г Ӽ ϱ
        /// </summary>
        /// <param name="sourceCollection">ҽ ÷</param>
        /// <param name="panelStyle">г Ÿ</param>
        public static void SetPanelProperties(Control.ControlCollection sourceCollection, PanelStyle panelStyle)
        {
            ArrayList basePanelList = FindBasePanelList(true, sourceCollection);

            if(basePanelList != null)
            {
                foreach(BasePanel basePanel in basePanelList)
                {
                    basePanel.PanelStyle = panelStyle;
                }
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region Ʈ Ʈ ã - FindControlList(baseType, searchAllChildren, sourceCollection, foundControlList)

        /// <summary>
        /// Ʈ Ʈ ã
        /// </summary>
        /// <param name="baseType">̽ Ÿ</param>
        /// <param name="searchAllChildren"> ڽ ã </param>
        /// <param name="sourceCollection">ҽ ÷</param>
        /// <param name="foundControlList">ã Ʈ Ʈ</param>
        /// <returns>ã Ʈ Ʈ</returns>
        private static ArrayList FindControlList(Type baseType, bool searchAllChildren, Control.ControlCollection sourceCollection, ArrayList foundControlList)
        {
            if((sourceCollection == null) || (foundControlList == null))
            {
                return null;
            }

            try
            {
                for(int i = 0; i < sourceCollection.Count; i++)
                {
                    if((sourceCollection[i] != null) && baseType.IsAssignableFrom(sourceCollection[i].GetType()))
                    {
                        foundControlList.Add(sourceCollection[i]);
                    }
                }

                if(searchAllChildren == false)
                {
                    return foundControlList;
                }

                for(int j = 0; j < sourceCollection.Count; j++)
                {
                    if(((sourceCollection[j] != null) && !(sourceCollection[j] is Form)) && ((sourceCollection[j].Controls != null) && (sourceCollection[j].Controls.Count > 0)))
                    {
                        foundControlList = FindControlList(baseType, searchAllChildren, sourceCollection[j].Controls, foundControlList);
                    }
                }
            }
            catch(Exception exception)
            {
                if(IsCriticalException(exception))
                {
                    throw;
                }
            }

            return foundControlList;
        }

        #endregion

        #region ġ   ϱ - IsCriticalException(exception)

        /// <summary>
        /// ġ   ϱ
        /// </summary>
        /// <param name="exception"></param>
        /// <returns>ġ  </returns>
        private static bool IsCriticalException(Exception exception)
        {
            return (exception is NullReferenceException  ) ||
                   (exception is StackOverflowException  ) ||
                   (exception is OutOfMemoryException    ) ||
                   (exception is ThreadAbortException    ) ||
                   (exception is ExecutionEngineException) ||
                   (exception is IndexOutOfRangeException) ||
                   (exception is AccessViolationException);
        }

        #endregion
    }
}