﻿using System.Collections.Generic;
using System.Drawing;

namespace TestProject
{
    /// <summary>
    /// 베이스 패널 색상
    /// </summary>
	public class BasePanelColor : PanelColor
	{
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 패널 스타일 - PanelStyle

        /// <summary>
        /// 패널 스타일
        /// </summary>
        public override PanelStyle PanelStyle
        {
            get
            {
                return PanelStyle.Office2007;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - BasePanelColor()

        /// <summary>
        /// 생성자
        /// </summary>
        public BasePanelColor() : base()
		{
		}

        #endregion
        #region 생성자 - BasePanelColor(basePanel)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="basePanel">베이스 패널</param>
        public BasePanelColor(BasePanel basePanel) : base(basePanel)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 색상 초기화하기 - InitializeColor(sourceDictionary)

        /// <summary>
        /// 색상 초기화하기
        /// </summary>
        /// <param name="sourceDictionary">소스 딕셔너리</param>
		protected override void InitializeColor(Dictionary<KnownColor, Color> sourceDictionary)
		{
			base.InitializeColor(sourceDictionary);

            sourceDictionary[KnownColor.CaptionBarSelectedBeginColor              ] = Color.FromArgb(156, 163, 254);
            sourceDictionary[KnownColor.CaptionBarSelectedEndColor                ] = Color.FromArgb(90 , 98 , 254);
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarCheckedBeginColor  ] = Color.FromArgb(136, 144, 254);
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarCheckedEndColor    ] = Color.FromArgb(111, 145, 255);
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarCheckedMiddleColor ] = Color.FromArgb(42 , 52 , 254);
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarPressedBeginColor  ] = Color.FromArgb(106, 109, 228);
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarPressedEndColor    ] = Color.FromArgb(88 , 111, 226);
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarPressedMiddleColor ] = Color.FromArgb(39 , 39 , 217);
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarSelectedBeginColor ] = Color.FromArgb(156, 163, 254);
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarSelectedEndColor   ] = Color.FromArgb(139, 164, 255);
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarSelectedMiddleColor] = Color.FromArgb(90 , 98 , 254);
            sourceDictionary[KnownColor.ExpanderPanelCaptionTextSelectedColor     ] = Color.White;
		}

		#endregion
	}
}