﻿using System.Collections.Generic;
using System.Drawing;

namespace TestProject
{
    /// <summary>
    /// 오피스 패널 색상
    /// </summary>
	public class OfficePanelColor : PanelColor
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 패널 스타일 - PanelStyle

        /// <summary>
        /// 패널 스타일
        /// </summary>
        public override PanelStyle PanelStyle
        {
            get
            {
                return PanelStyle.Office2007;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - OfficePanelColor()

        /// <summary>
        /// 생성자
        /// </summary>
        public OfficePanelColor() : base()
		{
		}

        #endregion
        #region 생성자 - OfficePanelColor(basePanel)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="basePanel">베이스 패널</param>
		public OfficePanelColor(BasePanel basePanel) : base(basePanel)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 색상 초기화하기 - InitializeColor(sourceDictionary)

        /// <summary>
        /// 색상 초기화하기
        /// </summary>
        /// <param name="sourceDictionary">소스 딕셔너리</param>
        protected override void InitializeColor(Dictionary<KnownColor, Color> sourceDictionary)
		{
			base.InitializeColor(sourceDictionary);

            sourceDictionary[KnownColor.CaptionBarSelectedBeginColor              ] = Color.FromArgb(255, 255, 220);
            sourceDictionary[KnownColor.CaptionBarSelectedEndColor                ] = Color.FromArgb(247, 193, 94 );
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarCheckedBeginColor  ] = Color.FromArgb(255, 217, 170);
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarCheckedEndColor    ] = Color.FromArgb(254, 225, 122);
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarCheckedMiddleColor ] = Color.FromArgb(255, 171, 63 );
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarPressedBeginColor  ] = Color.FromArgb(255, 189, 105);
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarPressedEndColor    ] = Color.FromArgb(254, 211, 100);
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarPressedMiddleColor ] = Color.FromArgb(251, 140, 60 );
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarSelectedBeginColor ] = Color.FromArgb(255, 252, 222);
			sourceDictionary[KnownColor.ExpanderPanelCaptionBarSelectedEndColor   ] = Color.FromArgb(255, 230, 158);
			sourceDictionary[KnownColor.ExpanderPanelCaptionBarSelectedMiddleColor] = Color.FromArgb(255, 215, 103);
			sourceDictionary[KnownColor.ExpanderPanelCaptionTextSelectedColor     ] = Color.Black;
		}

		#endregion
	}
}