using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// г 
    /// </summary>
    public class PanelColor
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Enumeration
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ˷  - KnownColor

        /// <summary>
        /// ˷ 
        /// </summary>
        public enum KnownColor
        {
            /// <summary>
            /// ׵θ 
            /// </summary>
            BorderColor,

            /// <summary>
            /// ݱ ư 
            /// </summary>
            CloseButtonColor,

            /// <summary>
            /// Ȯ ư 
            /// </summary>
            ExpandButtonColor,

            /// <summary>
            ///    
            /// </summary>
            CaptionBarBeginColor,

            /// <summary>
            ///    
            /// </summary>
            CaptionBarEndColor,

            /// <summary>
            ///   ߰ 
            /// </summary>
            CaptionBarMiddleColor,

            /// <summary>
            ///     
            /// </summary>
            CaptionBarSelectedBeginColor,

            /// <summary>
            ///     
            /// </summary>
            CaptionBarSelectedEndColor,

            /// <summary>
            /// Ʈ  
            /// </summary>
            ContentBeginColor,

            /// <summary>
            /// Ʈ  
            /// </summary>
            ContentEndColor,

            /// <summary>
            ///  ؽƮ 
            /// </summary>
            CaptionTextColor,

            /// <summary>
            ///  ؽƮ  
            /// </summary>
            CaptionTextCollapsedColor,

            /// <summary>
            ///  ׵θ 
            /// </summary>
            InnerBorderColor,

            /// <summary>
            /// ͽҴ г  
            /// </summary>
            ExpanderPanelBackgroundColor,

            /// <summary>
            /// ͽҴ г ݱ ư 
            /// </summary>
            ExpanderPanelCloseButtonColor,

            /// <summary>
            /// ͽҴ г Ȯ ư 
            /// </summary>
            ExpanderPanelExpandButtonColor,

            /// <summary>
            /// ͽҴ г  ؽƮ 
            /// </summary>
            ExpanderPanelCaptionTextColor,

            /// <summary>
            /// ͽҴ г    
            /// </summary>
            ExpanderPanelCaptionBarBeginColor,

            /// <summary>
            /// ͽҴ г    
            /// </summary>
            ExpanderPanelCaptionBarEndColor,

            /// <summary>
            /// ͽҴ г   ߰ 
            /// </summary>
            ExpanderPanelCaptionBarMiddleColor,

            /// <summary>
            /// ͽҴ г   ÷  
            /// </summary>
            ExpanderPanelCaptionBarFlatBeginColor,

            /// <summary>
            /// ͽҴ г   ÷  
            /// </summary>
            ExpanderPanelCaptionBarFlatEndColor,

            /// <summary>
            /// ͽҴ г   PRESS  
            /// </summary>
            ExpanderPanelCaptionBarPressedBeginColor,

            /// <summary>
            /// ͽҴ г   PRESS  
            /// </summary>
            ExpanderPanelCaptionBarPressedEndColor,

            /// <summary>
            /// ͽҴ г   PRESS ߰ 
            /// </summary>
            ExpanderPanelCaptionBarPressedMiddleColor,

            /// <summary>
            /// ͽҴ г   üũ  
            /// </summary>
            ExpanderPanelCaptionBarCheckedBeginColor,

            /// <summary>
            /// ͽҴ г   üũ  
            /// </summary>
            ExpanderPanelCaptionBarCheckedEndColor,

            /// <summary>
            /// ͽҴ г   üũ ߰ 
            /// </summary>
            ExpanderPanelCaptionBarCheckedMiddleColor,

            /// <summary>
            /// ͽҴ г     
            /// </summary>
            ExpanderPanelCaptionBarSelectedBeginColor,

            /// <summary>
            /// ͽҴ г     
            /// </summary>
            ExpanderPanelCaptionBarSelectedEndColor,

            /// <summary>
            /// ͽҴ г    ߰ 
            /// </summary>
            ExpanderPanelCaptionBarSelectedMiddleColor,

            /// <summary>
            /// ͽҴ г  ؽƮ  
            /// </summary>
            ExpanderPanelCaptionTextSelectedColor
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ̽ г
        /// </summary>
        private BasePanel basePanel;

        /// <summary>
        /// ų  ̺
        /// </summary>
        private System.Windows.Forms.ProfessionalColorTable professionalColorTable;

        /// <summary>
        /// ˷  ųʸ
        /// </summary>
        private Dictionary<KnownColor, Color> knownColorDictionary;

        /// <summary>
        /// ý   
        /// </summary>
        private bool useSystemColor;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region г - Panel

        /// <summary>
        /// г
        /// </summary>
        public BasePanel Panel
        {
            get
            {
                return this.basePanel;
            }
            set
            {
                this.basePanel = value;
            }
        }

        #endregion
        #region г Ÿ - PanelStyle

        /// <summary>
        /// г Ÿ
        /// </summary>
        public virtual PanelStyle PanelStyle
        {
            get
            {
                return PanelStyle.Default;
            }
        }

        #endregion
        #region ý    - UseSystemColor

        /// <summary>
        /// ý   
        /// </summary>
        public bool UseSystemColor
        {
            get
            {
                return this.useSystemColor;
            }
            set
            {
                if(value.Equals(this.useSystemColor) == false)
                {
                    this.useSystemColor = value;

                    this.professionalColorTable.UseSystemColors = this.useSystemColor;

                    Clear();
                }
            }
        }

        #endregion

        #region ׵θ  - BorderColor

        /// <summary>
        /// ׵θ 
        /// </summary>
        public virtual Color BorderColor
        {
            get
            {
                return GetColor(KnownColor.BorderColor);
            }
        }

        #endregion
        #region ݱ ư  - CloseButtonColor

        /// <summary>
        /// ݱ ư 
        /// </summary>
        public virtual Color CloseButtonColor
        {
            get
            {
                return GetColor(KnownColor.CloseButtonColor);
            }
        }

        #endregion
        #region Ȯ ư  - ExpandButtonColor

        /// <summary>
        /// Ȯ ư 
        /// </summary>
        public virtual Color ExpandButtonColor
        {
            get
            {
                return GetColor(KnownColor.ExpandButtonColor);
            }
        }

        #endregion
        #region     - CaptionBarBeginColor

        /// <summary>
        ///    
        /// </summary>
        public virtual Color CaptionBarBeginColor
        {
            get
            {
                return GetColor(KnownColor.CaptionBarBeginColor);
            }
        }

        #endregion
        #region     - CaptionBarEndColor

        /// <summary>
        ///    
        /// </summary>
        public virtual Color CaptionBarEndColor
        {
            get
            {
                return GetColor(KnownColor.CaptionBarEndColor);
            }
        }

        #endregion
        #region   ߰  - CaptionBarMiddleColor

        /// <summary>
        ///   ߰ 
        /// </summary>
        public virtual Color CaptionBarMiddleColor
        {
            get
            {
                return GetColor(KnownColor.CaptionBarMiddleColor);
            }
        }

        #endregion
        #region      - CaptionBarSelectedBeginColor

        /// <summary>
        ///     
        /// </summary>
        public virtual Color CaptionBarSelectedBeginColor
        {
            get
            {
                return GetColor(KnownColor.CaptionBarSelectedBeginColor);
            }
        }

        #endregion
        #region      - CaptionBarSelectedEndColor

        /// <summary>
        ///     
        /// </summary>
        public virtual Color CaptionBarSelectedEndColor
        {
            get
            {
                return GetColor(KnownColor.CaptionBarSelectedEndColor);
            }
        }

        #endregion
        #region  ؽƮ  - CaptionTextColor

        /// <summary>
        ///  ؽƮ 
        /// </summary>
        public virtual Color CaptionTextColor
        {
            get
            {
                return GetColor(KnownColor.CaptionTextColor);
            }
        }

        #endregion
        #region  ؽƮ   - CaptionTextCollapsedColor

        /// <summary>
        ///  ؽƮ  
        /// </summary>
        public virtual Color CaptionTextCollapsedColor
        {
            get
            {
                return GetColor(KnownColor.CaptionTextCollapsedColor);
            }
        }

        #endregion
        #region Ʈ   - ContentBeginColor

        /// <summary>
        /// Ʈ  
        /// </summary>
        public virtual Color ContentBeginColor
        {
            get
            {
                return GetColor(KnownColor.ContentBeginColor);
            }
        }

        #endregion
        #region Ʈ   - ContentEndColor

        /// <summary>
        /// Ʈ  
        /// </summary>
        public virtual Color ContentEndColor
        {
            get
            {
                return GetColor(KnownColor.ContentEndColor);
            }
        }

        #endregion
        #region  ׵θ  - InnerBorderColor

        /// <summary>
        ///  ׵θ 
        /// </summary>
        public virtual Color InnerBorderColor
        {
            get
            {
                return GetColor(KnownColor.InnerBorderColor);
            }
        }

        #endregion
        #region ͽҴ г   - ExpanderPanelBackgroundColor

        /// <summary>
        /// ͽҴ г  
        /// </summary>
        public virtual Color ExpanderPanelBackgroundColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelBackgroundColor);
            }
        }

        #endregion
        #region ͽҴ г ݱ ư  - ExpanderPanelCloseButtonColor

        /// <summary>
        /// ͽҴ г ݱ ư 
        /// </summary>
        public virtual Color ExpanderPanelCloseButtonColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCloseButtonColor);
            }
        }

        #endregion
        #region ͽҴ г Ȯ ư  - ExpanderPanelExpandButtonColor

        /// <summary>
        /// ͽҴ г Ȯ ư 
        /// </summary>
        public virtual Color ExpanderPanelExpandButtonColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelExpandButtonColor);
            }
        }

        #endregion
        #region ͽҴ г     - ExpanderPanelCaptionBarBeginColor

        /// <summary>
        /// ͽҴ г    
        /// </summary>
        public virtual Color ExpanderPanelCaptionBarBeginColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionBarBeginColor);
            }
        }

        #endregion
        #region ͽҴ г     - ExpanderPanelCaptionBarEndColor

        /// <summary>
        /// ͽҴ г    
        /// </summary>
        public virtual Color ExpanderPanelCaptionBarEndColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionBarEndColor);
            }
        }

        #endregion
        #region ͽҴ г   ߰  - ExpanderPanelCaptionBarMiddleColor

        /// <summary>
        /// ͽҴ г   ߰ 
        /// </summary>
        public virtual Color ExpanderPanelCaptionBarMiddleColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionBarMiddleColor);
            }
        }

        #endregion
        #region ͽҴ г  ؽƮ  - ExpanderPanelCaptionTextColor

        /// <summary>
        /// ͽҴ г  ؽƮ 
        /// </summary>
        public virtual Color ExpanderPanelCaptionTextColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionTextColor);
            }
        }

        #endregion
        #region ͽҴ г   FLAT   - ExpanderPanelCaptionBarFlatBeginColor

        /// <summary>
        /// ͽҴ г   FLAT  
        /// </summary>
        public virtual Color ExpanderPanelCaptionBarFlatBeginColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionBarFlatBeginColor);
            }
        }

        #endregion
        #region ͽҴ г   FLAT   - ExpanderPanelCaptionBarFlatEndColor

        /// <summary>
        /// ͽҴ г   FLAT  
        /// </summary>
        public virtual Color ExpanderPanelCaptionBarFlatEndColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionBarFlatEndColor);
            }
        }

        #endregion
        #region ͽҴ г   PRESS   - ExpanderPanelCaptionBarPressedBeginColor

        /// <summary>
        /// ͽҴ г   PRESS  
        /// </summary>
        public virtual Color ExpanderPanelCaptionBarPressedBeginColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionBarPressedBeginColor);
            }
        }

        #endregion
        #region ͽҴ г   PRESS   - ExpanderPanelCaptionBarPressedEndColor

        /// <summary>
        /// ͽҴ г   PRESS  
        /// </summary>
        public virtual Color ExpanderPanelCaptionBarPressedEndColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionBarPressedEndColor);
            }
        }

        #endregion
        #region ͽҴ г   PRESS ߰  - ExpanderPanelCaptionBarPressedMiddleColor

        /// <summary>
        /// ͽҴ г   PRESS ߰ 
        /// </summary>
        public virtual Color ExpanderPanelCaptionBarPressedMiddleColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionBarPressedMiddleColor);
            }
        }

        #endregion
        #region ͽҴ г   üũ   - ExpanderPanelCaptionBarCheckedBeginColor

        /// <summary>
        /// ͽҴ г   üũ  
        /// </summary>
        public virtual Color ExpanderPanelCaptionBarCheckedBeginColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionBarCheckedBeginColor);
            }
        }

        #endregion
        #region ͽҴ г   üũ   - ExpanderPanelCaptionBarCheckedEndColor

        /// <summary>
        /// ͽҴ г   üũ  
        /// </summary>
        public virtual Color ExpanderPanelCaptionBarCheckedEndColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionBarCheckedEndColor);
            }
        }

        #endregion
        #region ͽҴ г   üũ ߰  - ExpanderPanelCaptionBarCheckedMiddleColor

        /// <summary>
        /// ͽҴ г   üũ ߰ 
        /// </summary>
        public virtual Color ExpanderPanelCaptionBarCheckedMiddleColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionBarCheckedMiddleColor);
            }
        }

        #endregion
        #region ͽҴ г      - ExpanderPanelCaptionBarSelectedBeginColor

        /// <summary>
        /// ͽҴ г     
        /// </summary>
        public virtual Color ExpanderPanelCaptionBarSelectedBeginColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionBarSelectedBeginColor);
            }
        }

        #endregion
        #region ͽҴ г      - ExpanderPanelCaptionBarSelectedEndColor

        /// <summary>
        /// ͽҴ г     
        /// </summary>
        public virtual Color ExpanderPanelCaptionBarSelectedEndColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionBarSelectedEndColor);
            }
        }

        #endregion
        #region ͽҴ г    ߰  - ExpanderPanelCaptionBarSelectedMiddleColor

        /// <summary>
        /// ͽҴ г    ߰ 
        /// </summary>
        public virtual Color ExpanderPanelCaptionBarSelectedMiddleColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionBarSelectedMiddleColor);
            }
        }

        #endregion
        #region ͽҴ г  ؽƮ   - ExpanderPanelCaptionBarTextSelectedColor

        /// <summary>
        /// ͽҴ г  ؽƮ  
        /// </summary>
        public virtual Color ExpanderPanelCaptionBarTextSelectedColor
        {
            get
            {
                return GetColor(KnownColor.ExpanderPanelCaptionTextSelectedColor);
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region ˷  ųʸ - KnownColorDictionary

        /// <summary>
        /// ˷  ųʸ
        /// </summary>
        private Dictionary<KnownColor, Color> KnownColorDictionary
        {
            get
            {
                if(this.knownColorDictionary == null)
                {
                    this.knownColorDictionary = new Dictionary<KnownColor, Color>(0xd4);

                    if((this.basePanel != null) && (this.basePanel.ColorScheme == ColorScheme.Professional))
                    {
                        if((this.useSystemColor == true) || (ToolStripManager.VisualStylesEnabled == false))
                        {
                            InitializeBaseColor(this.knownColorDictionary);
                        }
                        else
                        {
                            InitializeColor(this.knownColorDictionary);
                        }
                    }
                    else
                    {
                        InitializeCustomColor(this.knownColorDictionary);
                    }
                }

                return this.knownColorDictionary;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - PanelColor()

        /// <summary>
        /// 
        /// </summary>
        public PanelColor()
        {
            this.professionalColorTable = new System.Windows.Forms.ProfessionalColorTable();
        }

        #endregion
        #region  - PanelColor(basePanel)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="basePanel">̽ г</param>
        public PanelColor(BasePanel basePanel) : this()
        {
            this.basePanel = basePanel;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region  ϱ - GetColor(knownColor)

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <param name="knownColor">˷ </param>
        /// <returns></returns>
        internal Color GetColor(KnownColor knownColor)
        {
            return (Color)KnownColorDictionary[knownColor];
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Clear()

        /// <summary>
        /// 
        /// </summary>
        public void Clear()
        {
            ResetKnownColorDictionary();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region  ʱȭϱ - InitializeColor(sourceDictionary)

        /// <summary>
        ///  ʱȭϱ
        /// </summary>
        /// <param name="sourceDictionary">ҽ ųʸ</param>
        protected virtual void InitializeColor(Dictionary<KnownColor, Color> sourceDictionary)
        {
            InitializeBaseColor(sourceDictionary);
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region ⺻  ʱȭϱ - InitializeBaseColor(sourceDictionary)

        /// <summary>
        /// ⺻  ʱȭϱ
        /// </summary>
        /// <param name="sourceDictionary">ҽ ųʸ</param>
        private void InitializeBaseColor(Dictionary<KnownColor, Color> sourceDictionary)
        {
            sourceDictionary[KnownColor.BorderColor                               ] = this.professionalColorTable.GripDark;
            sourceDictionary[KnownColor.InnerBorderColor                          ] = this.professionalColorTable.GripLight;
            sourceDictionary[KnownColor.CloseButtonColor                          ] = SystemColors.ControlText;
            sourceDictionary[KnownColor.ExpandButtonColor                         ] = SystemColors.ControlText;
            sourceDictionary[KnownColor.CaptionBarBeginColor                      ] = this.professionalColorTable.ToolStripGradientBegin;
            sourceDictionary[KnownColor.CaptionBarEndColor                        ] = this.professionalColorTable.ToolStripGradientEnd;
            sourceDictionary[KnownColor.CaptionBarMiddleColor                     ] = this.professionalColorTable.ToolStripGradientMiddle;
            sourceDictionary[KnownColor.CaptionBarSelectedBeginColor              ] = this.professionalColorTable.ButtonSelectedGradientBegin;
            sourceDictionary[KnownColor.CaptionBarSelectedEndColor                ] = this.professionalColorTable.ButtonSelectedGradientEnd;
            sourceDictionary[KnownColor.ContentBeginColor                         ] = this.professionalColorTable.ToolStripContentPanelGradientBegin;
            sourceDictionary[KnownColor.ContentEndColor                           ] = this.professionalColorTable.ToolStripContentPanelGradientEnd;
            sourceDictionary[KnownColor.CaptionTextColor                          ] = SystemColors.ControlText;
            sourceDictionary[KnownColor.CaptionTextCollapsedColor                 ] = SystemColors.ControlText;
            sourceDictionary[KnownColor.ExpanderPanelBackgroundColor              ] = this.professionalColorTable.ToolStripContentPanelGradientBegin;
            sourceDictionary[KnownColor.ExpanderPanelCloseButtonColor             ] = SystemColors.ControlText;
            sourceDictionary[KnownColor.ExpanderPanelExpandButtonColor            ] = SystemColors.ControlText;
            sourceDictionary[KnownColor.ExpanderPanelCaptionTextColor             ] = SystemColors.ControlText;
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarBeginColor         ] = this.professionalColorTable.ToolStripGradientBegin;
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarEndColor           ] = this.professionalColorTable.ToolStripGradientEnd;
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarMiddleColor        ] = this.professionalColorTable.ToolStripGradientMiddle;
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarFlatBeginColor     ] = this.professionalColorTable.ToolStripGradientMiddle;
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarFlatEndColor       ] = this.professionalColorTable.ToolStripGradientBegin;
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarPressedBeginColor  ] = this.professionalColorTable.ButtonPressedGradientBegin;
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarPressedEndColor    ] = this.professionalColorTable.ButtonPressedGradientEnd;
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarPressedMiddleColor ] = this.professionalColorTable.ButtonPressedGradientMiddle;
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarCheckedBeginColor  ] = this.professionalColorTable.ButtonCheckedGradientBegin;
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarCheckedEndColor    ] = this.professionalColorTable.ButtonCheckedGradientEnd;
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarCheckedMiddleColor ] = this.professionalColorTable.ButtonCheckedGradientMiddle;
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarSelectedBeginColor ] = this.professionalColorTable.ButtonSelectedGradientBegin;
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarSelectedEndColor   ] = this.professionalColorTable.ButtonSelectedGradientEnd;
            sourceDictionary[KnownColor.ExpanderPanelCaptionBarSelectedMiddleColor] = this.professionalColorTable.ButtonSelectedGradientMiddle;
            sourceDictionary[KnownColor.ExpanderPanelCaptionTextSelectedColor     ] = SystemColors.ControlText;
        }

        #endregion
        #region Ŀ  ʱȭϱ - InitializeCustomColor(sourceDictionary)

        /// <summary>
        /// Ŀ  ʱȭϱ
        /// </summary>
        /// <param name="sourceDictionary">ҽ ųʸ</param>
        private void InitializeCustomColor(Dictionary<KnownColor, Color> sourceDictionary)
        {
            Panel panel = this.basePanel as Panel;

            if(panel != null)
            {
                sourceDictionary[KnownColor.BorderColor                 ] = panel.CustomColor.BorderColor;
                sourceDictionary[KnownColor.InnerBorderColor            ] = panel.CustomColor.InnerBorderColor;
                sourceDictionary[KnownColor.CloseButtonColor            ] = panel.CustomColor.CloseButtonColor;
                sourceDictionary[KnownColor.ExpandButtonColor           ] = panel.CustomColor.ExpandButtonColor;
                sourceDictionary[KnownColor.CaptionBarBeginColor        ] = panel.CustomColor.CaptionBarBeginColor;
                sourceDictionary[KnownColor.CaptionBarEndColor          ] = panel.CustomColor.CaptionBarEndColor;
                sourceDictionary[KnownColor.CaptionBarMiddleColor       ] = panel.CustomColor.CaptionBarMiddleColor;
                sourceDictionary[KnownColor.CaptionBarSelectedBeginColor] = panel.CustomColor.CaptionBarSelectedBeginColor;
                sourceDictionary[KnownColor.CaptionBarSelectedEndColor  ] = panel.CustomColor.CaptionBarSelectedEndColor;
                sourceDictionary[KnownColor.ContentBeginColor           ] = panel.CustomColor.ContentBeginColor;
                sourceDictionary[KnownColor.ContentEndColor             ] = panel.CustomColor.ContentEndColor;
                sourceDictionary[KnownColor.CaptionTextColor            ] = panel.CustomColor.CaptionText;
                sourceDictionary[KnownColor.CaptionTextCollapsedColor   ] = panel.CustomColor.CaptionTextCollapsedColor;
            }

            ExpanderPanel expanderPanel = this.basePanel as ExpanderPanel;

            if(expanderPanel != null)
            {
                sourceDictionary[KnownColor.BorderColor                               ] = expanderPanel.CustomColor.BorderColor;
                sourceDictionary[KnownColor.InnerBorderColor                          ] = expanderPanel.CustomColor.InnerBorderColor;
                sourceDictionary[KnownColor.ExpanderPanelBackgroundColor              ] = expanderPanel.CustomColor.BackgroundColor;
                sourceDictionary[KnownColor.ExpanderPanelCloseButtonColor             ] = expanderPanel.CustomColor.CloseButtonColor;
                sourceDictionary[KnownColor.ExpanderPanelExpandButtonColor            ] = expanderPanel.CustomColor.ExpandButtonColor;
                sourceDictionary[KnownColor.ExpanderPanelCaptionTextColor             ] = expanderPanel.CustomColor.CaptionText;
                sourceDictionary[KnownColor.ExpanderPanelCaptionBarBeginColor         ] = expanderPanel.CustomColor.CaptionBarBeginColor;
                sourceDictionary[KnownColor.ExpanderPanelCaptionBarEndColor           ] = expanderPanel.CustomColor.CaptionBarEndColor;
                sourceDictionary[KnownColor.ExpanderPanelCaptionBarMiddleColor        ] = expanderPanel.CustomColor.CaptionBarMiddleColor;
                sourceDictionary[KnownColor.ExpanderPanelCaptionBarFlatBeginColor     ] = expanderPanel.CustomColor.CaptionBarFlatBeginColor;
                sourceDictionary[KnownColor.ExpanderPanelCaptionBarFlatEndColor       ] = expanderPanel.CustomColor.CaptionBarFlatEndColor;
                sourceDictionary[KnownColor.ExpanderPanelCaptionBarPressedBeginColor  ] = expanderPanel.CustomColor.CaptionBarPressedBeginColor;
                sourceDictionary[KnownColor.ExpanderPanelCaptionBarPressedEndColor    ] = expanderPanel.CustomColor.CaptionBarPressedEndColor;
                sourceDictionary[KnownColor.ExpanderPanelCaptionBarPressedMiddleColor ] = expanderPanel.CustomColor.CaptionBarPressedMiddleColor;
                sourceDictionary[KnownColor.ExpanderPanelCaptionBarCheckedBeginColor  ] = expanderPanel.CustomColor.CaptionBarCheckedBeginColor;
                sourceDictionary[KnownColor.ExpanderPanelCaptionBarCheckedEndColor    ] = expanderPanel.CustomColor.CaptionBarCheckedEndColor;
                sourceDictionary[KnownColor.ExpanderPanelCaptionBarCheckedMiddleColor ] = expanderPanel.CustomColor.CaptionBarCheckedMiddleColor;
                sourceDictionary[KnownColor.ExpanderPanelCaptionBarSelectedBeginColor ] = expanderPanel.CustomColor.CaptionBarSelectedBeginColor;
                sourceDictionary[KnownColor.ExpanderPanelCaptionBarSelectedEndColor   ] = expanderPanel.CustomColor.CaptionBarSelectedEndColor;
                sourceDictionary[KnownColor.ExpanderPanelCaptionBarSelectedMiddleColor] = expanderPanel.CustomColor.CaptionBarSelectedMiddleColor;
                sourceDictionary[KnownColor.ExpanderPanelCaptionTextSelectedColor     ] = expanderPanel.CustomColor.CaptionTextSelectedColor;
            }
        }

        #endregion
        #region ˷  ųʸ ϱ - ResetKnownColorDictionary()

        /// <summary>
        /// ˷  ųʸ ϱ
        /// </summary>
        private void ResetKnownColorDictionary()
        {
            if(this.knownColorDictionary != null)
            {
                this.knownColorDictionary.Clear();
            }

            this.knownColorDictionary = null;
        }

        #endregion
    }
}