using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

using TestProject.Properties;

namespace TestProject
{
    /// <summary>
    /// г
    /// </summary>
    [Designer(typeof(PanelDesigner)),
    DesignTimeVisibleAttribute(true)]
    [DefaultEvent("CloseButtonClick")]
    [ToolboxBitmap(typeof(System.Windows.Forms.Panel))]
    public partial class Panel : BasePanel
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        ///   簢
        /// </summary>
        private Rectangle restoreBoundRectangle;

        /// <summary>
        /// ͽҴ г ų Ÿ
        /// </summary>
        private bool showExpanderPanelProfessionalStyle;

        /// <summary>
        /// Ŀ 
        /// </summary>
        private PanelCustomColor customColor;

        /// <summary>
        ///   ǥ 
        /// </summary>
        private bool showTransparentBackground;

        /// <summary>
        ///  ȣ ̹
        /// </summary>
        private Image backgroundHoverImage;

        /// <summary>
        ///  ׶Ʈ 
        /// </summary>
        private LinearGradientMode linearGradientMode;

        /// <summary>
        ///   ǥ 
        /// </summary>
        private bool showCaptionBar;

        /// <summary>
        /// ݱ ư ̹
        /// </summary>
        private Image closeButtonImage;

        /// <summary>
        ///  ø
        /// </summary>
        private System.Windows.Forms.Splitter associatedSplitter;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ÷ 簢 - DisplayRectangle

        /// <summary>
        /// ÷ 簢
        /// </summary>
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override Rectangle DisplayRectangle
        {
            get
            {
                Padding padding = this.Padding;

                Rectangle displayRectangle = new Rectangle
                (
                    this.ClientRectangle.Left   + padding.Left,
                    this.ClientRectangle.Top    + padding.Top,
                    this.ClientRectangle.Width  - padding.Left - padding.Right,
                    this.ClientRectangle.Height - padding.Top  - padding.Bottom
                );
                
                if(this.showCaptionBar == true)
                {
                    if(Controls.Count > 0)
                    {
                        ExpanderPanelList expanderPanelList = Controls[0] as ExpanderPanelList;

                        if((expanderPanelList != null) && (expanderPanelList.Dock == DockStyle.Fill))
                        {
                            displayRectangle = new Rectangle
                            (
                                padding.Left,
                                this.CaptionHeight + padding.Top + ConstantHelper.BORDER_THICKNESS,
                                this.ClientRectangle.Width - padding.Left - padding.Right,
                                this.ClientRectangle.Height - this.CaptionHeight - padding.Top - padding.Bottom - (2 * ConstantHelper.BORDER_THICKNESS)
                            );
                        }
                        else
                        {
                            displayRectangle = new Rectangle
                            (
                                padding.Left + ConstantHelper.BORDER_THICKNESS,
                                this.CaptionHeight + padding.Top + ConstantHelper.BORDER_THICKNESS,
                                this.ClientRectangle.Width - padding.Left - padding.Right - (2 * ConstantHelper.BORDER_THICKNESS),
                                this.ClientRectangle.Height - this.CaptionHeight - padding.Top - padding.Bottom - (2 * ConstantHelper.BORDER_THICKNESS)
                            );
                        }
                    }
                }

                return displayRectangle;
            }
        }

        #endregion
        #region   簢 - RestoreBoundRectangle

        /// <summary>
        ///   簢
        /// </summary>
        [Browsable(false)]
        public Rectangle RestoreBoundRectangle
        {
            get
            {
                return this.restoreBoundRectangle;
            }
        }

        #endregion
        #region  ø - AssociatedSplitter

        /// <summary>
        ///  ø
        /// </summary>
        [Category(nameof(Panel))]
        public virtual System.Windows.Forms.Splitter AssociatedSplitter
        {
            get
            {
                return this.associatedSplitter;
            }
            set
            {
                this.associatedSplitter = value;
            }
        }

        #endregion

        #region ͽҴ г ų Ÿ - ShowExpanderPanelProfessionalStyle

        /// <summary>
        /// ͽҴ г ų Ÿ
        /// </summary>
        [Category(nameof(Panel))]
        [DefaultValue(false)]
        public bool ShowExpanderPanelProfessionalStyle
        {
            get
            {
                return this.showExpanderPanelProfessionalStyle;
            }
            set
            {
                if(value.Equals(this.showExpanderPanelProfessionalStyle) == false)
                {
                    this.showExpanderPanelProfessionalStyle = value;

                    Invalidate(false);
                }
            }
        }

        #endregion
        #region Ŀ  - CustomColor

        /// <summary>
        /// Ŀ 
        /// </summary>
        [Category(nameof(Panel))]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
        public PanelCustomColor CustomColor
        {
            get
            {
                return this.customColor;
            }
        }

        #endregion
        #region   ǥ  - ShowTransparentBackground

        /// <summary>
        ///   ǥ 
        /// </summary>
        [Category(nameof(Panel))]
        [DefaultValue(true)]
        public bool ShowTransparentBackground
        {
            get
            {
                return this.showTransparentBackground;
            }
            set
            {
                if(value.Equals(this.showTransparentBackground) == false)
                {
                    this.showTransparentBackground = value;

                    Invalidate(false);
                }
            }
        }

        #endregion
        #region  ׶Ʈ  - LinearGradientMode

        /// <summary>
        ///  ׶Ʈ 
        /// </summary>
        [Category(nameof(Panel))]
        [DefaultValue(1)]
        public LinearGradientMode LinearGradientMode
        {
            get
            {
                return this.linearGradientMode;
            }
            set
            {
                if(value.Equals(this.linearGradientMode) == false)
                {
                    this.linearGradientMode = value;

                    Invalidate(false);
                }
            }
        }

        #endregion
        #region   ǥ  - ShowCaptionBar

        /// <summary>
        ///   ǥ 
        /// </summary>
        [Category(nameof(Panel))]
        [DefaultValue(true)]
        public bool ShowCaptionBar
        {
            get
            {
                return this.showCaptionBar;
            }
            set
            {
                if(value.Equals(this.showCaptionBar) == false)
                {
                    this.showCaptionBar = value;

                    Invalidate(true);
                }
            }
        }

        #endregion
        #region Ȯ  - Expanded

        /// <summary>
        /// Ȯ 
        /// </summary>
        [Browsable(false)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override bool Expanded
        {
            get
            {
                return base.Expanded;
            }
            set
            {
                base.Expanded = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Panel()

        /// <summary>
        /// 
        /// </summary>
        public Panel()
        {
            InitializeComponent();

            CaptionFont                        = new Font(SystemFonts.CaptionFont.FontFamily, SystemFonts.CaptionFont.SizeInPoints + 2.75F, FontStyle.Bold);
            BackColor                          = Color.Transparent;
            ForeColor                          = SystemColors.ControlText;
            ShowTransparentBackground          = true;
            ShowExpanderPanelProfessionalStyle = false;
            ColorScheme                        = ColorScheme.Professional;
            LinearGradientMode                 = LinearGradientMode.Vertical;
            Expanded                           = true;
            CaptionHeight                      = 27;
            ImageSize                          = new Size(18, 18);
            
            this.showCaptionBar = true;

            this.customColor = new PanelCustomColor();

            this.customColor.CustomColorChanged += customColor_CustomColorChanged;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region  ̹ ϱ - GetBackgroundImage(graphics, imageRectangle, beginColor, endColor)

        /// <summary>
        ///  ̹ ϱ
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="imageRectangle">̹ 簢</param>
        /// <param name="beginColor"> </param>
        /// <param name="endColor"> </param>
        /// <returns> ̹</returns>
        private static Image GetBackgroundImage(Graphics graphics, Rectangle imageRectangle, Color beginColor, Color endColor)
        {
            Rectangle rectangle = imageRectangle;

            rectangle.X = 0;
            rectangle.Y = 0;

            Image image = new Bitmap(imageRectangle.Width, imageRectangle.Height, graphics);

            using(Graphics imageGraphics = Graphics.FromImage(image))
            {
                RenderPanelBackground
                (
                    imageGraphics,
                    rectangle,
                    beginColor,
                    endColor,
                    LinearGradientMode.Vertical
                );
            }

            return image;
        }

        #endregion
        #region ׵θ ׸ - DrawBorder(graphics, panelRectangle, captionRectangle, borderColor, innerBorderColor)

        /// <summary>
        /// ׵θ ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="panelRectangle">г 簢</param>
        /// <param name="captionRectangle"> 簢</param>
        /// <param name="borderColor">׵θ </param>
        /// <param name="innerBorderColor"> ׵θ </param>
        private static void DrawBorder(Graphics graphics, Rectangle panelRectangle, Rectangle captionRectangle, Color borderColor, Color innerBorderColor)
        {
            using(Pen borderPen = new Pen(borderColor))
            {
                Rectangle innerBorderRectangle = captionRectangle;

                innerBorderRectangle.Width -= ConstantHelper.BORDER_THICKNESS;

                innerBorderRectangle.Offset(ConstantHelper.BORDER_THICKNESS, ConstantHelper.BORDER_THICKNESS);

                ControlPaint.DrawBorder
                (
                    graphics,
                    innerBorderRectangle,
                    innerBorderColor,
                    ButtonBorderStyle.Solid
                );

                ControlPaint.DrawBorder
                (
                    graphics,
                    panelRectangle,
                    borderColor,
                    ButtonBorderStyle.Solid
                );

                graphics.DrawLine
                (
                    borderPen,
                    captionRectangle.X,
                    captionRectangle.Y + captionRectangle.Height,
                    captionRectangle.Width,
                    captionRectangle.Y + captionRectangle.Height
                );

                if(panelRectangle.Height == captionRectangle.Height)
                {
                    return;
                }

                Rectangle panelBorderRectangle = panelRectangle;

                panelBorderRectangle.Y      =  captionRectangle.Height;
                panelBorderRectangle.Height -= captionRectangle.Height + (int)borderPen.Width;
                panelBorderRectangle.Width  -= (int)borderPen.Width;

                Point[] pointArray =
                {
                    new Point(panelBorderRectangle.X, panelBorderRectangle.Y),
                    new Point(panelBorderRectangle.X, panelBorderRectangle.Y + panelBorderRectangle.Height),
                    new Point(panelBorderRectangle.X + panelBorderRectangle.Width, panelBorderRectangle.Y + panelBorderRectangle.Height),
                    new Point(panelBorderRectangle.X + panelBorderRectangle.Width, panelBorderRectangle.Y)
                };

                graphics.DrawLines(borderPen, pointArray);
            }
        }

        #endregion
        #region Ȯ ư ̹ ϱ - GetExpandButtonImage(dockStyle, expanded)

        /// <summary>
        /// Ȯ ư ̹ ϱ
        /// </summary>
        /// <param name="dockStyle">ŷ Ÿ</param>
        /// <param name="expanded">Ȯ </param>
        /// <returns>Ȯ ư ̹</returns>
        private static Image GetExpandButtonImage(DockStyle dockStyle, bool expanded)
        {
            Image image = null;

            if((dockStyle == DockStyle.Left) && (expanded == true))
            {
                image = Resources.ChevronLeft;
            }
            else if((dockStyle == DockStyle.Left) && (expanded == false))
            {
                image = Resources.ChevronRight;
            }
            else if((dockStyle == DockStyle.Right) && (expanded == true))
            {
                image = Resources.ChevronRight;
            }
            else if((dockStyle == DockStyle.Right) && (expanded == false))
            {
                image = Resources.ChevronLeft;
            }
            else if((dockStyle == DockStyle.Top) && (expanded == true))
            {
                image = Resources.ChevronUp;
            }
            else if((dockStyle == DockStyle.Top) && (expanded == false))
            {
                image = Resources.ChevronDown;
            }
            else if((dockStyle == DockStyle.Bottom) && (expanded == true))
            {
                image = Resources.ChevronDown;
            }
            else if((dockStyle == DockStyle.Bottom) && (expanded == false))
            {
                image = Resources.ChevronUp;
            }

            return image;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region г  ϱ - SetPanelColor(panelColor)

        /// <summary>
        /// г  ϱ
        /// </summary>
        /// <param name="panelColor">г </param>
        public override void SetPanelColor(PanelColor panelColor)
        {
            this.backgroundHoverImage = null;

            base.SetPanelColor(panelColor);
        }

        #endregion
        #region Ʈ Ÿ ׸ - DrawDefaultStyle(graphics, captionRectangle, beginColor, endColor, middleColor)

        /// <summary>
        /// Ʈ Ÿ ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="captionRectangle"> 簢</param>
        /// <param name="beginColor"> </param>
        /// <param name="endColor"> </param>
        /// <param name="middleColor">߰ </param>
        private static void DrawDefaultStyle(Graphics graphics, Rectangle captionRectangle, Color beginColor, Color endColor, Color middleColor)
        {
            RenderCaptionBarBackground
            (
                graphics,
                captionRectangle,
                beginColor,
                middleColor,
                endColor,
                LinearGradientMode.Vertical,
                true
            );
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Protected

        #region ũ  óϱ - OnResize(e)

        /// <summary>
        /// ũ  óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnResize(EventArgs e)
        {
            if(ShowExpandButton == true)
            {
                if(Expanded == false)
                {
                    if((Dock == DockStyle.Left) || (Dock == DockStyle.Right))
                    {
                        if(Width > CaptionHeight)
                        {
                            Expanded = true;
                        }
                    }

                    if((Dock == DockStyle.Top) || (Dock == DockStyle.Bottom))
                    {
                        if(Height > CaptionHeight)
                        {
                            Expanded = true;
                        }
                    }
                }
                else
                {
                    if((Dock == DockStyle.Left) || (Dock == DockStyle.Right))
                    {
                        if(Width == CaptionHeight)
                        {
                            Expanded = false;
                        }
                    }

                    if((Dock == DockStyle.Top) || (Dock == DockStyle.Bottom))
                    {
                        if(Height == CaptionHeight)
                        {
                            Expanded = false;
                        }
                    }
                }
            }

            base.OnResize(e);
        }

        #endregion
        #region Ʈ  óϱ - OnCreateControl()

        /// <summary>
        /// Ʈ  óϱ
        /// </summary>
        protected override void OnCreateControl()
        {
            this.restoreBoundRectangle = ClientRectangle;

            MinimumSize = new Size(CaptionHeight, CaptionHeight);

            base.OnCreateControl();
        }

        #endregion
        #region  Ʈ óϱ - OnPaintBackground(e)

        /// <summary>
        ///  Ʈ óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnPaintBackground(PaintEventArgs e)
        {
            base.OnPaintBackground(e);

            if(ShowTransparentBackground == true)
            {
                BackColor = Color.Transparent;
            }
            else
            {
                Rectangle boundRectangle = ClientRectangle;

                if(this.showCaptionBar == true)
                {
                    BackColor = Color.Transparent;

                    boundRectangle = new Rectangle
                    (
                        ClientRectangle.Left,
                        ClientRectangle.Top    + CaptionHeight,
                        ClientRectangle.Width,
                        ClientRectangle.Height - CaptionHeight
                    );
                }

                RenderPanelBackground
                (
                    e.Graphics,
                    boundRectangle,
                    PanelColor.ContentBeginColor,
                    PanelColor.ContentEndColor,
                    LinearGradientMode
                );
            }
        }

        #endregion
        #region Ʈ óϱ - OnPaint(e)

        /// <summary>
        /// Ʈ óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnPaint(PaintEventArgs e)
        {
            PanelStyle panelStyle = PanelStyle;

            if(this.showCaptionBar == false)
            {
                return;
            }

            using(AntiAliasHelper antiAliasHelper = new AntiAliasHelper(e.Graphics))
            {
                Graphics graphics = e.Graphics;

                using(ClearTypeGridFitHelper clearTypeGridFitHelper = new ClearTypeGridFitHelper(graphics))
                {
                    Rectangle captionRectangle = CaptionRectangle;

                    Color beginColor  = PanelColor.CaptionBarBeginColor;
                    Color middleColor = PanelColor.CaptionBarMiddleColor;
                    Color endColor    = PanelColor.CaptionBarEndColor;
                    Color textColor   = PanelColor.CaptionTextColor;

                    bool showExpanderPanelProfessionalStyle = ShowExpanderPanelProfessionalStyle;

                    ColorScheme colorScheme = ColorScheme;
                    
                    if((showExpanderPanelProfessionalStyle == true) && (colorScheme == ColorScheme.Professional) && (panelStyle != PanelStyle.Office2007))
                    {
                        beginColor  = PanelColor.ExpanderPanelCaptionBarBeginColor;
                        middleColor = PanelColor.ExpanderPanelCaptionBarMiddleColor;
                        endColor    = PanelColor.ExpanderPanelCaptionBarEndColor;
                        textColor   = PanelColor.ExpanderPanelCaptionTextColor;
                    }
                    
                    Image       image           = Image;
                    RightToLeft rightToLeft     = RightToLeft;
                    Font        captionFont     = CaptionFont;
                    Rectangle   clientRectangle = ClientRectangle;
                    string      text            = Text;
                    DockStyle   dockStyle       = Dock;
                    bool        expanded        = Expanded;

                    if(this.closeButtonImage == null)
                    {
                        this.closeButtonImage = Resources.ClosePanel;
                    }

                    Color closeButtonColor = PanelColor.CloseButtonColor;

                    if(closeButtonColor == Color.Empty)
                    {
                        closeButtonColor = textColor;
                    }

                    bool showExpandButton = ShowExpandButton;
                    bool showCloseButton  = ShowCloseButton;

                    switch(panelStyle)
                    {
                        case PanelStyle.Default    :
                        case PanelStyle.Office2007 :

                            DrawDefaultStyle
                            (
                                graphics,
                                captionRectangle,
                                beginColor,
                                endColor,
                                middleColor
                            );

                            break;
                    }

                    DrawBorder
                    (
                        graphics,
                        clientRectangle,
                        captionRectangle,
                        PanelColor.BorderColor,
                        PanelColor.InnerBorderColor
                    );

                    if((dockStyle == DockStyle.Fill) || (dockStyle == DockStyle.None) || ((showExpandButton == false) && (showCloseButton == false)))
                    {
                        DrawImageAndText
                        (
                            graphics,
                            captionRectangle,
                            CAPTION_SPACING,
                            this.ImageRectangle,
                            image,
                            rightToLeft,
                            captionFont,
                            textColor,
                            text
                        );

                        return;
                    }

                    if((showExpandButton == true) || (showCloseButton == true))
                    {
                        Image expandButtonImage = GetExpandButtonImage(dockStyle, expanded);

                        DrawImageAndText
                        (
                            graphics,
                            dockStyle,
                            CAPTION_SPACING,
                            captionRectangle,
                            clientRectangle,
                            ImageRectangle,
                            image,
                            rightToLeft,
                            showCloseButton,
                            this.closeButtonImage,
                            closeButtonColor,
                            ref CloseButtonRectangle,
                            showExpandButton,
                            expanded,
                            expandButtonImage,
                            textColor,
                            ref ExpandButtonRectangle,
                            captionFont,
                            textColor,
                            PanelColor.CaptionTextCollapsedColor,
                            text
                        );

                        if(this.backgroundHoverImage == null)
                        {
                            this.backgroundHoverImage = GetBackgroundImage
                            (
                                graphics,
                                ImageRectangle,
                                PanelColor.CaptionBarSelectedBeginColor,
                                PanelColor.CaptionBarSelectedEndColor
                            );
                        }

                        if(this.backgroundHoverImage != null)
                        {
                            Rectangle closeButtonRectangle = this.CloseButtonRectangle;

                            if(closeButtonRectangle != Rectangle.Empty)
                            {
                                if(this.CloseButtonHoverState == HoverState.Hover)
                                {
                                    graphics.DrawImage(this.backgroundHoverImage, closeButtonRectangle);

                                    DrawImage(graphics, this.closeButtonImage, closeButtonRectangle, closeButtonColor, closeButtonRectangle.Y);
                                }
                            }

                            Rectangle expandButtonRectangle = ExpandButtonRectangle;

                            if(expandButtonRectangle != Rectangle.Empty)
                            {
                                if(ExpandButtonHoverState == HoverState.Hover)
                                {
                                    graphics.DrawImage(this.backgroundHoverImage, expandButtonRectangle);

                                    DrawImage(graphics, expandButtonImage, expandButtonRectangle, textColor, expandButtonRectangle.Y);
                                }
                            }
                        }
                    }
                }
            }
        }

        #endregion
        #region ǥ   óϱ - OnVisibleChanged(e)

        /// <summary>
        /// ǥ   óϱ
        /// </summary>
        /// <param name="e">̺Ʈ ߻</param>
        protected override void OnVisibleChanged(EventArgs e)
        {
            System.Windows.Forms.Splitter associatedSplitter = AssociatedSplitter;

            if(associatedSplitter != null)
            {
                associatedSplitter.Visible = this.Visible;
            }

            base.OnVisibleChanged(e);
        }

        #endregion

        #region г Ÿ  óϱ - OnPanelStyleChanged(sender, e)

        /// <summary>
        /// г Ÿ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected override void OnPanelStyleChanged(object sender, PanelStyleChangedEventArgs e)
        {
            OnLayout(new LayoutEventArgs(this, null));

            base.OnPanelStyleChanged(sender, e);
        }

        #endregion
        #region Ȯ ư ȣ   óϱ - OnExpandButtonHoverStateChanged(sender, e)

        /// <summary>
        /// Ȯ ư ȣ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected override void OnExpandButtonHoverStateChanged(object sender, HoverStateChangedEventArgs e)
        {
            Invalidate(ExpandButtonRectangle);

            base.OnExpandButtonHoverStateChanged(sender, e);
        }

        #endregion
        #region Ȯ ư Ŭ óϱ - OnExpandButtonClick(sender, e)

        /// <summary>
        /// Ȯ ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected override void OnExpandButtonClick(object sender, EventArgs e)
        {
            Expanded = !Expanded;

            base.OnExpandButtonClick(sender, e);
        }

        #endregion
        #region ݱ ư ȣ   óϱ - OnCloseButtonHoverStateChanged(sender, e)

        /// <summary>
        /// ݱ ư ȣ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected override void OnCloseButtonHoverStateChanged(object sender, HoverStateChangedEventArgs e)
        {
            Invalidate(CloseButtonRectangle);

            base.OnCloseButtonHoverStateChanged(sender, e);
        }

        #endregion
        #region г ҽ óϱ - OnPanelCollapsed(sender, e)

        /// <summary>
        /// г ҽ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected override void OnPanelCollapsed(object sender, PanelStateChangedEventArgs e)
        {
            if((Dock == DockStyle.Left) || (Dock == DockStyle.Right))
            {
                foreach(Control control in Controls)
                {
                    control.Hide();
                }
            }
            
            if((Dock == DockStyle.Left) || (Dock == DockStyle.Right))
            {
                if(ClientRectangle.Width > CaptionHeight)
                {
                    this.restoreBoundRectangle = ClientRectangle;
                }

                Width = CaptionHeight;
            }
            
            if((Dock == DockStyle.Top) || (Dock == DockStyle.Bottom))
            {
                if(ClientRectangle.Height > CaptionHeight)
                {
                    this.restoreBoundRectangle = ClientRectangle;
                }

                Height = CaptionHeight;
            }

            base.OnPanelCollapsed(sender, e);
        }

        #endregion
        #region г Ȯ óϱ - OnPanelExpanded(sender, e)

        /// <summary>
        /// г Ȯ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected override void OnPanelExpanded(object sender, PanelStateChangedEventArgs e)
        {
            if((Dock == DockStyle.Left) || (Dock == DockStyle.Right))
            {
                foreach(Control control in Controls)
                {
                    control.Show();
                }

                if(ClientRectangle.Width == CaptionHeight)
                {
                    Width = this.restoreBoundRectangle.Width;
                }
            }

            if((Dock == DockStyle.Top) || (Dock == DockStyle.Bottom))
            {
                Height = this.restoreBoundRectangle.Height;
            }

            base.OnPanelExpanded(sender, e);
        }

        #endregion
    }
}