using System.Drawing;
using System.Collections.Generic;

namespace TestProject
{
    /// <summary>
    /// BLUE  ̺
    /// </summary>
    public class BlueColorTable : TestProject.BaseColorTable
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        private PanelColor panelColor;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region г  - PanelColor

        /// <summary>
        /// г 
        /// </summary>
        public override PanelColor PanelColor
        {
            get
            {
                if(this.panelColor == null)
                {
                    this.panelColor = new BluePanelColor();
                }

                return this.panelColor;
            }
        }

        #endregion
        
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region  ʱȭϱ - InitializeColor(sourceDictionary)

        /// <summary>
        ///  ʱȭϱ
        /// </summary>
        /// <param name="sourceDictionary">ҽ ųʸ</param>
        protected override void InitializeColor(Dictionary<ProfessionalColorTable.KnownColor, Color> sourceDictionary)
        {
            base.InitializeColor(sourceDictionary);

            sourceDictionary[KnownColor.ButtonPressedBorder                  ] = Color.FromArgb(145, 153, 164);
            sourceDictionary[KnownColor.ButtonPressedGradientBegin           ] = Color.FromArgb(141, 170, 253);
            sourceDictionary[KnownColor.ButtonPressedGradientEnd             ] = Color.FromArgb(98 , 101, 252);
            sourceDictionary[KnownColor.ButtonPressedGradientMiddle          ] = Color.FromArgb(43 , 93 , 255);
            sourceDictionary[KnownColor.ButtonSelectedGradientBegin          ] = Color.FromArgb(188, 205, 254);
            sourceDictionary[KnownColor.ButtonSelectedGradientEnd            ] = Color.FromArgb(153, 155, 253);
            sourceDictionary[KnownColor.ButtonSelectedGradientMiddle         ] = Color.FromArgb(111, 145, 255);
			sourceDictionary[KnownColor.ButtonSelectedHighlightBorder        ] = Color.FromArgb(145, 153, 164);
            sourceDictionary[KnownColor.GripDark                             ] = Color.FromArgb(102, 102, 102);
            sourceDictionary[KnownColor.GripLight                            ] = Color.FromArgb(182, 182, 182);
            sourceDictionary[KnownColor.ImageMarginGradientBegin             ] = Color.FromArgb(239, 239, 239);
            sourceDictionary[KnownColor.MenuBorder                           ] = Color.FromArgb(0  , 0  , 0  );
            sourceDictionary[KnownColor.MenuItemSelectedGradientBegin        ] = Color.FromArgb(231, 239, 243);
            sourceDictionary[KnownColor.MenuItemSelectedGradientEnd          ] = Color.FromArgb(218, 235, 243);
            sourceDictionary[KnownColor.MenuItemText                         ] = Color.FromArgb(255, 255, 255);
            sourceDictionary[KnownColor.MenuItemTopLevelSelectedBorder       ] = Color.FromArgb(145, 153, 164);
            sourceDictionary[KnownColor.MenuItemTopLevelSelectedGradientBegin] = Color.FromArgb(205, 208, 213);
            sourceDictionary[KnownColor.MenuStripGradientBegin               ] = Color.FromArgb(128, 128, 255);
            sourceDictionary[KnownColor.MenuStripGradientEnd                 ] = Color.FromArgb(0  , 0  , 128);
            sourceDictionary[KnownColor.OverflowButtonGradientBegin          ] = Color.FromArgb(166, 189, 254);
            sourceDictionary[KnownColor.OverflowButtonGradientEnd            ] = Color.FromArgb(119, 123, 253);
            sourceDictionary[KnownColor.OverflowButtonGradientMiddle         ] = Color.FromArgb(63 , 108, 253);
            sourceDictionary[KnownColor.RaftingContainerGradientBegin        ] = Color.FromArgb(83 , 83 , 83 );
            sourceDictionary[KnownColor.RaftingContainerGradientEnd          ] = Color.FromArgb(83 , 83 , 83 );
            sourceDictionary[KnownColor.SeparatorDark                        ] = Color.FromArgb(102, 102, 102);
            sourceDictionary[KnownColor.SeparatorLight                       ] = Color.FromArgb(182, 182, 182);
            sourceDictionary[KnownColor.StatusStripGradientBegin             ] = Color.FromArgb(128, 128, 255);
            sourceDictionary[KnownColor.StatusStripGradientEnd               ] = Color.FromArgb(0  , 0  , 128);
			sourceDictionary[KnownColor.StatusStripText                      ] = Color.FromArgb(255, 255, 255);
            sourceDictionary[KnownColor.ToolStripBorder                      ] = Color.FromArgb(102, 102, 102);
            sourceDictionary[KnownColor.ToolStripContentPanelGradientBegin   ] = Color.FromArgb(0  , 0  , 139);
            sourceDictionary[KnownColor.ToolStripContentPanelGradientEnd     ] = Color.FromArgb(0  , 0  , 128);
            sourceDictionary[KnownColor.ToolStripDropDownBackground          ] = Color.FromArgb(250, 250, 250);
            sourceDictionary[KnownColor.ToolStripGradientBegin               ] = Color.FromArgb(128, 128, 255);
            sourceDictionary[KnownColor.ToolStripGradientEnd                 ] = Color.FromArgb(0  , 0  , 139);
            sourceDictionary[KnownColor.ToolStripGradientMiddle              ] = Color.FromArgb(0  , 0  , 128);
            sourceDictionary[KnownColor.ToolStripPanelGradientBegin          ] = Color.FromArgb(0  , 0  , 128);
            sourceDictionary[KnownColor.ToolStripPanelGradientEnd            ] = Color.FromArgb(0  , 0  , 128);
            sourceDictionary[KnownColor.ToolStripText                        ] = Color.FromArgb(255, 255, 255);
        }

        #endregion
    }
}