using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// OFFICE 2007 
    /// </summary>
    public class Office2007Renderer : ToolStripProfessionalRenderer
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// Թ 
        /// </summary>
        private static int _insetMargin;

        /// <summary>
        ///  Ʈ 
        /// </summary>
        private static Blend _statusStripBlend;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Static

        #region  - Office2007Renderer()

        /// <summary>
        /// 
        /// </summary>
        static Office2007Renderer()
        {
            _insetMargin = 2;

            _statusStripBlend = new Blend();

            _statusStripBlend.Positions = new float[] { 0.0f, 0.2f, 0.3f, 0.4f, 0.8f, 1.0f };
            _statusStripBlend.Factors   = new float[] { 0.3f, 0.4f, 0.5f, 1.0f, 0.8f, 0.7f };
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region  - Office2007Renderer()

        /// <summary>
        /// 
        /// </summary>
        public Office2007Renderer() : base(new Office2007BlueColorTable())
        {
            this.ColorTable.UseSystemColors = false;
        }

        #endregion
        #region  - Office2007Renderer(professionalColorTable)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="professionalColorTable">ų  ̺</param>
        public Office2007Renderer(ProfessionalColorTable professionalColorTable) : base(professionalColorTable)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region ȭǥ  óϱ - OnRenderArrow(e)

        /// <summary>
        /// ȭǥ  óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnRenderArrow(ToolStripArrowRenderEventArgs e)
        {
            if(ColorTable.UseSystemColors == false)
            {
                ProfessionalColorTable colorTable = ColorTable as ProfessionalColorTable;

                if(colorTable != null)
                {
                    if((e.Item.Owner.GetType() == typeof(MenuStrip)) && (e.Item.Selected == false) && e.Item.Pressed == false)
                    {
                        if(colorTable.MenuItemText != Color.Empty)
                        {
                            e.ArrowColor = colorTable.MenuItemText;
                        }
                    }

                    if((e.Item.Owner.GetType() == typeof(StatusStrip)) && (e.Item.Selected == false) && e.Item.Pressed == false)
                    {
                        if(colorTable.StatusStripText != Color.Empty)
                        {
                            e.ArrowColor = colorTable.StatusStripText;
                        }
                    }
                }
            }

            base.OnRenderArrow(e);
        }

        #endregion
        #region ׸ ؽƮ  óϱ - OnRenderItemText(e)

        /// <summary>
        /// ׸ ؽƮ  óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnRenderItemText(ToolStripItemTextRenderEventArgs e)
        {
            if(ColorTable.UseSystemColors == false)
            {
                ProfessionalColorTable colorTable = ColorTable as ProfessionalColorTable;

                if(colorTable != null)
                {
                    if((e.ToolStrip is MenuStrip) && (e.Item.Selected == false) && e.Item.Pressed == false)
                    {
                        if(colorTable.MenuItemText != Color.Empty)
                        {
                            e.TextColor = colorTable.MenuItemText;
                        }
                    }

                    if((e.ToolStrip is StatusStrip) && (e.Item.Selected == false) && e.Item.Pressed == false)
                    {
                        if(colorTable.StatusStripText != Color.Empty)
                        {
                            e.TextColor = colorTable.StatusStripText;
                        }
                    }
                }
            }

            base.OnRenderItemText(e);
        }

        #endregion
        #region  Ʈ Ʈ    óϱ - OnRenderToolStripContentPanelBackground(e)

        /// <summary>
        ///  Ʈ Ʈ    óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnRenderToolStripContentPanelBackground(ToolStripContentPanelRenderEventArgs e)
        {
            base.OnRenderToolStripContentPanelBackground(e);

            if(ColorTable.UseSystemColors == false)
            {
                if((e.ToolStripContentPanel.Width > 0) && (e.ToolStripContentPanel.Height > 0))
                {
                    using
                    (
                        LinearGradientBrush brush = new LinearGradientBrush
                        (
                            e.ToolStripContentPanel.ClientRectangle,
                            ColorTable.ToolStripContentPanelGradientBegin,
                            ColorTable.ToolStripContentPanelGradientEnd,
                            LinearGradientMode.Vertical
                        )
                    )
                    {
                        e.Graphics.FillRectangle(brush, e.ToolStripContentPanel.ClientRectangle);
                    }
                }
            }
        }

        #endregion
        #region и  óϱ - OnRenderSeparator(e)

        /// <summary>
        /// и  óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnRenderSeparator(ToolStripSeparatorRenderEventArgs e)
        {
            if(ColorTable.UseSystemColors == false)
            {
                e.Item.ForeColor = ColorTable.RaftingContainerGradientBegin;
            }

            base.OnRenderSeparator(e);
        }

        #endregion
        #region  Ʈ   óϱ - OnRenderToolStripBackground(e)

        /// <summary>
        ///  Ʈ   óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnRenderToolStripBackground(ToolStripRenderEventArgs e)
        {
            if(ColorTable.UseSystemColors == true)
            {
                base.OnRenderToolStripBackground(e);
            }
            else
            {
                if(e.ToolStrip is StatusStrip)
                {
                    RectangleF rectangle = new RectangleF(0, 0, e.ToolStrip.Width, e.ToolStrip.Height);

                    if((rectangle.Width > 0) && (rectangle.Height > 0))
                    {
                        using
                        (
                            LinearGradientBrush brush = new LinearGradientBrush
                            (
                                rectangle,
                                ColorTable.StatusStripGradientBegin,
                                ColorTable.StatusStripGradientEnd,
                                LinearGradientMode.Vertical
                            )
                        )
                        {
                            brush.Blend = _statusStripBlend;

                            e.Graphics.FillRectangle(brush, rectangle);
                        }
                    }
                }
                else
                {
                    base.OnRenderToolStripBackground(e);
                }
            }
        }

        #endregion
        #region ̹   óϱ - OnRenderImageMargin(e)

        /// <summary>
        /// ̹   óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnRenderImageMargin(ToolStripRenderEventArgs e)
        {
            if(ColorTable.UseSystemColors == true)
            {
                base.OnRenderToolStripBackground(e);
            }
            else
            {
                if((e.ToolStrip is ContextMenuStrip) || (e.ToolStrip is ToolStripDropDownMenu))
                {
                    Rectangle marginRectangle = e.AffectedBounds;

                    bool isRightToLeft = (e.ToolStrip.RightToLeft == RightToLeft.Yes);

                    marginRectangle.Y      += _insetMargin;
                    marginRectangle.Height -= _insetMargin * 2;

                    if(isRightToLeft == false)
                    {
                        marginRectangle.X += _insetMargin;
                    }
                    else
                    {
                        marginRectangle.X += _insetMargin / 2;
                    }

                    using(SolidBrush brush = new SolidBrush(ColorTable.ImageMarginGradientBegin))
                    {
                        e.Graphics.FillRectangle(brush, marginRectangle);
                    }
                }
                else
                {
                    base.OnRenderImageMargin(e);
                }
            }
        }

        #endregion
    }
}